/***************************************************
 *                                                 *
 *   NWMap v. 1.1                                  *
 *   Copyright 2001, by Jason Harris               *
 *   http://nwmap.nwnonline.net/                   *
 *   nwmap@hotmail.com                             *
 *   jharris@30doradus.org                         *
 *                                                 *
 ***************************************************/
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "AddTilesetFormMain.h"
#include "NWMapMain.h"
#include "YesNoMain.h"
#include "NWConst.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TAddTilesetForm *AddTilesetForm;
//---------------------------------------------------------------------------

__fastcall TAddTilesetForm::TAddTilesetForm(TComponent* Owner)
    : TForm(Owner)
{
    Preview = new Graphics::TBitmap();
    Preview->Width = NXTILES*TILESIZE + 2;
    Preview->Height = NYTILES*TILESIZE + 2;
}
//---------------------------------------------------------------------------

void __fastcall TAddTilesetForm::Button1Click(TObject *Sender)
{
    OpenDialog->InitialDir = Form1->NWMDir;

    if (OpenDialog->Execute()) {
        if (Sender==Button1) {
            FileName0Text->Text = OpenDialog->FileName;
        }
        if (Sender==Button2) {
            FileName1Text->Text = OpenDialog->FileName;
        }
        if (Sender==Button3) {
            FileName2Text->Text = OpenDialog->FileName;
        }
        if (Sender==Button4) {
            FileName3Text->Text = OpenDialog->FileName;
        }
        if (Sender==Button5) {
            FileName4Text->Text = OpenDialog->FileName;
        }
    }
}
//---------------------------------------------------------------------------

void __fastcall TAddTilesetForm::FileNameTextChange(TObject *Sender)
{
    TEdit *FileNameText = (TEdit *)Sender;

    if (FileExists(FileNameText->Text)) {
        Preview->LoadFromFile(FileNameText->Text);

        if (Preview->Width != NXTILES*TILESIZE + 2 || Preview->Height != NYTILES*TILESIZE + 2) {
            YesNo->Message->Caption = "The specified Bitmap is not 802 x 802 pixels.  Proceed anyway?";
            if (YesNo->ShowModal() != mrOk) {
                FileNameText->Text = "";
                return;
            }
        }
        PreviewBox->Canvas->StretchDraw(Rect(0,0,PreviewBox->Width,PreviewBox->Height), Preview);

    } else if (FileNameText->Text != "") {
        Application->MessageBox( "No such file", 0, MB_OK );
    }
}
//---------------------------------------------------------------------------



