/***************************************************
 *                                                 *
 *   NWMap v. 1.1                                  *
 *   Copyright 2001, by Jason Harris               *
 *   http://nwmap.nwnonline.net/                   *
 *   nwmap@hotmail.com                             *
 *   jharris@30doradus.org                         *
 *                                                 *
 ***************************************************/
//---------------------------------------------------------------------------
#include <vcl.h>
#include <stdlib.h>
#pragma hdrstop

#include "DoorFormMain.h"
#include "NWMapMain.h"
#include "TilesetFormMain.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TDoorForm *DoorForm;
//---------------------------------------------------------------------------
__fastcall TDoorForm::TDoorForm(TComponent* Owner)
    : TForm(Owner)
{
    x1[0]=22; x2[0]=60; y1[0]=20; y2[0]=23;  //North
    X1[0]=34; X2[0]=48; Y1[0]=16; Y2[0]=26;
    x1[1]=60; x2[1]=63; y1[1]=22; y2[1]=60;  //East
    X1[1]=56; X2[1]=66; Y1[1]=34; Y2[1]=48;
    x1[2]=22; x2[2]=60; y1[2]=60; y2[2]=63;  //South
    X1[2]=34; X2[2]=48; Y1[2]=56; Y2[2]=66;
    x1[3]=20; x2[3]=23; y1[3]=22; y2[3]=60;  //West
    X1[3]=16; X2[3]=26; Y1[3]=34; Y2[3]=48;
    x1[4]=22; x2[4]=60; y1[4]=39; y2[4]=41;  //Center horizontal
    X1[4]=34; X2[4]=48; Y1[4]=35; Y2[4]=45;
    x1[5]=39; x2[5]=41; y1[5]=22; y2[5]=60;  //Center vertical
    X1[5]=35; X2[5]=45; Y1[5]=34; Y2[5]=48;
}
//---------------------------------------------------------------------------

void __fastcall TDoorForm::FormShow(TObject *Sender)
{
    Left = Form1->Left + 100;
    Top = Form1->Top + 100;

    TileX = Form1->CurrentTileX;
    TileY = Form1->CurrentTileY;

    bool wd = Form1->WantDoors;
    Form1->WantDoors = false;
    Form1->drawTile( TileX, TileY ); // paint current tile on Form1->Tile bitmap
    Form1->WantDoors = wd;

    DoorList->ItemIndex=-1;
    DoorType->ItemIndex=-1;
}
//---------------------------------------------------------------------------

void TDoorForm::drawDoors(int X, int Y, TCanvas *c, int w) {
    c->Brush->Color = clWhite;
    c->Pen->Width = w;

    if (Form1->WantDoors) {
        for (int i=0; i<5; ++i) {
            switch (abs(Form1->Doors[X][Y][i])) {
                case 0: // No door
                    break;
                case 1: // Normal door
                    if (Form1->Doors[X][Y][i]<0) ++i;  //only i==4 can have negative Door
                    c->Pen->Color = clBlack;
                    c->Brush->Color = clWhite;
                    c->Rectangle(x1[i], y1[i], x2[i], y2[i]);
                    c->Rectangle(X1[i], Y1[i], X2[i], Y2[i]);
                    break;
                case 2: // Locked door
                    if (Form1->Doors[X][Y][i]<0) ++i;
                    c->Pen->Color = clBlack;
                    c->Brush->Color = clBlack;
                    c->Rectangle(x1[i], y1[i], x2[i], y2[i]);
                    c->Rectangle(X1[i], Y1[i], X2[i], Y2[i]);
                    break;
                case 3: // Hidden door
                    if (Form1->Doors[X][Y][i]<0) ++i;
                    c->Pen->Color = clBlack;
                    c->Brush->Color = clSilver;
                    c->Rectangle(x1[i], y1[i], x2[i], y2[i]);
                    c->Rectangle(X1[i], Y1[i], X2[i], Y2[i]);
                    break;
                case 4: // Secret door
                    if (Form1->Doors[X][Y][i]<0) ++i;
                    c->Pen->Color = clBlack;
                    c->Brush->Color = clGreen;
                    c->Rectangle(x1[i], y1[i], x2[i], y2[i]);
                    c->Rectangle(X1[i], Y1[i], X2[i], Y2[i]);
                    break;
                case 5: // One-way door
                    if (Form1->Doors[X][Y][i]<0) ++i;
                    c->Pen->Color = clBlack;
                    c->Brush->Color = clGray;
                    c->Rectangle(x1[i], y1[i], x2[i], y2[i]);
                    c->Rectangle(X1[i], Y1[i], X2[i], Y2[i]);
                    break;
                case 6: // False door
                    if (Form1->Doors[X][Y][i]<0) ++i;
                    c->Pen->Color = clGray;
                    c->Brush->Color = clGray;
                    c->Rectangle(x1[i], y1[i], x2[i], y2[i]);
                    c->Rectangle(X1[i], Y1[i], X2[i], Y2[i]);
                    break;
                case 7: // Triggered door
                    if (Form1->Doors[X][Y][i]<0) ++i;
                    c->Pen->Color = clBlack;
                    c->Brush->Color = clYellow;
                    c->Rectangle(x1[i], y1[i], x2[i], y2[i]);
                    c->Rectangle(X1[i], Y1[i], X2[i], Y2[i]);
                    break;
             }
        }
    }
}
//---------------------------------------------------------------------------

void TDoorForm::DoorGeometry(void) {
    //Define door geometry; default to original dungeon doors.
    //If using city tileset, adjust door positions.


    if (TilesetForm->iset==1) { //non-City tileset
        y1[0]= 9; y2[0]=11;  //North
        Y1[0]= 5; Y2[0]=15;
        x1[1]=69; x2[1]=71;  //East
        X1[1]=65; X2[1]=75;
        y1[2]=69; y2[2]=71;  //South
        Y1[2]=65; Y2[2]=75;
        x1[3]= 9; x2[3]=11;  //West
        X1[3]= 5; X2[3]=15;
    } else {
        y1[0]=19; y2[0]=21;
        Y1[0]=15; Y2[0]=15;
        x1[1]=59; x2[1]=61;
        X1[1]=55; X2[1]=65;
        y1[2]=59; y2[2]=61;
        Y1[2]=55; Y2[2]=65;
        x1[3]=19; x2[3]=21;
        X1[3]=15; X2[3]=25;
    }
}
//---------------------------------------------------------------------------

void __fastcall TDoorForm::DoorListClick(TObject *Sender)
{
    if (DoorList->ItemIndex==5) {
        DoorType->ItemIndex = -1*Form1->Doors[TileX][TileY][4]; // get rid of minus sign
    } else {
        DoorType->ItemIndex = Form1->Doors[TileX][TileY][DoorList->ItemIndex];
    }
}
//---------------------------------------------------------------------------

void __fastcall TDoorForm::DoorTypeChange(TObject *Sender)
{
    TileBox->Canvas->StretchDraw(Rect(0,0,TileBox->Width, TileBox->Height), Form1->Tile);

    if (DoorList->ItemIndex==5) {
        Form1->Doors[TileX][TileY][4] = -1*DoorType->ItemIndex;
        drawDoors(TileX, TileY, TileBox->Canvas);
    } else {
        Form1->Doors[TileX][TileY][DoorList->ItemIndex] = DoorType->ItemIndex;
        drawDoors(TileX, TileY, TileBox->Canvas);
    }
}
//---------------------------------------------------------------------------
void __fastcall TDoorForm::TileBoxPaint(TObject *Sender)
{
    TileBox->Canvas->StretchDraw(Rect(0,0,TileBox->Width, TileBox->Height), Form1->Tile);
    drawDoors(TileX, TileY, TileBox->Canvas);
}
//---------------------------------------------------------------------------

