/***************************************************
 *                                                 *
 *   NWMap v. 1.2                                  *
 *   Copyright 2001, by Jason Harris               *
 *   http://nwmap.nwnonline.net/                   *
 *   nwmap@hotmail.com                             *
 *   jharris@30doradus.org                         *
 *                                                 *
 *   Program developed with Borland C++ Builder 4  *
 *   It *may* work with BCB 5, but this is         *
 *   completely untested!                          *
 *                                                 *
 *   This source code is *only* available          *
 *   directly from the author, do not distribute!  *
 *                                                 *
 *   The code is rather sparsely commented,        *
 *   I'm working on improving this, but it's       *
 *   more fun to code than to document :)          *
 *                                                 *
 *   Please submit changes, comments, and          *
 *   suggestions to one of the above addresses     *
 *                                                 *
 *   Enjoy!                                        *
 *                                                 *
 ***************************************************/

//---------------------------------------------------------------------------
#include <vcl.h>
#include <algorithm>
#include <Printers.hpp>
#include <fstream.h>
#include <stdio.h>
#pragma hdrstop

#include "NWMapMain.h"
#include "NWConst.h"
#include "TilesetFormMain.h"
#include "Unit2.h"
#include "ChangeIDFormMain.h"
#include "TileDescMain.h"
#include "NewTilesetFormMain.h"
#include "YesNoMain.h"
#include "NWPopupFuncs.h"
#include "NWMenuFuncs.h"
#include "DoorFormMain.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
/**************Block: Global Variables**************/
TForm1 *Form1;


/**************Block: Form Control Functions**********/
//---------------------------------------------------------------------------

__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
    //Need to hardwire the size and location of components.  If large system
    //fonts are used instead of small fonts, then components get moved
    //around and/or resized.  Ridiculous!
    Left = 50;
    Top = 50;
    Width = 668;
    Height = 768;
    ClientWidth = 660;
    ClientHeight = 722;

    Label1->Caption = "Normal Draw";

    MapBox->Left = 0;
    MapBox->Top = 42;
    MapBox->Width = 640;
    MapBox->Height = 640;

    XScroll->Left = 0;
    XScroll->Top = 682;
    XScroll->Width = 640;
    XScroll->Height = 16;
    YScroll->Left = 642;
    YScroll->Top = 42;
    YScroll->Width = 16;
    YScroll->Height = 640;
    XTile->Left = 568;
    XTile->Top = 700;
    YTile->Left = 616;
    YTile->Top = 700;
    Label1->Top = 698;

    MBRect = Rect(0,0,MapBox->Width,MapBox->Height);
    TileRect = Rect(0,0,TILESIZE,TILESIZE);

    Map = new Graphics::TBitmap;
    Map->Width = MapBox->Width;
    Map->Height = MapBox->Height;

    Tile = new Graphics::TBitmap();
    Tile2 = new Graphics::TBitmap();
    SaveTile = new Graphics::TBitmap();
    //TileMask must be (re)created each time a mask is required...look in NWDrawFuncs
    TileMask2 = new Graphics::TBitmap();
    InvMask = new Graphics::TBitmap();

    Mask = new Graphics::TBitmap();
    Mask->LoadFromResourceName((int)HInstance, "MASK1");
    Mask2 = new Graphics::TBitmap();
    Mask2->LoadFromResourceName((int)HInstance, "MASK2");

    Tile->Width = TILESIZE;
    Tile->Height = TILESIZE;
    Tile2->Width = TILESIZE;
    Tile2->Height = TILESIZE;
    SaveTile->Width = TILESIZE;
    SaveTile->Height = TILESIZE;
    TileMask2->Width = TILESIZE;
    TileMask2->Height = TILESIZE;
    InvMask->Width = TILESIZE;
    InvMask->Height = TILESIZE;

    TileList = new TList();
    CutTileList = new TList();
    SavedStates = new TList();
    RedoStates = new TList();
    nwtClipboard = new NWTile();

    SelectButton->Glyph->LoadFromResourceName((int)HInstance, "SELECT");
    SelectButton->Hint = "Selection Mode";

    c = clMaroon;
    Map->Canvas->Pen->Color = c;
    RegionSelected = false;
    OneLayerMode = false;
    WantDoors = ViewDoors->Checked;
    WantLabels = ViewLabels->Checked;

    Zoom = 1.0;
    TileSize = int(ROOTSIZE*Zoom);
    ScrollStep = int(TileSize/SCRLUNIT);
    XScroll->Max = max(NSCRL - MapBox->Width/ScrollStep, 0);
    YScroll->Max = max(NSCRL - MapBox->Height/ScrollStep, 0);

    X0 = 0;  //X pixel location of upper left corner
    Y0 = 0;  //Y pixel location of upper left corner
    XTile0 = 0;  //X Tile offset of upper left corner
    YTile0 = 0;  //Y Tile offset of upper left corner
    LastTileX = -1;

    dx[0] = 0; dx[1]  = 1; dx[2] = 0; dx[3] = -1;
    dy[0] = -1; dy[1] = 0; dy[2] = 1; dy[3] =  0;
    val[0] = 1; val[1] = 2; val[2] = 4; val[3] = 8;

    //Initialize TileArray and RotArray
    for (int iy=0; iy<NYMAP; ++iy) {
        for (int ix=0; ix<NXMAP; ++ix) {
            for (int i=0; i<MLAYER; ++i) {
                if (i==0) {
                    TileArray[ix][iy][i] = 0;
                } else if (i==1) {
                    TileArray[ix][iy][i] = NTILES-1; //default transition layer to transparent
                } else {
                    TileArray[ix][iy][i] = 0;
                }
                RotArray[ix][iy][i] = 0;
            }
            for (int i=0; i<5; ++i) {
                Doors[ix][iy][i] = 0;
            }
        }
    }

    // Set working directory, NWMDir
    NWMDir = GetCurrentDir();
    // Initialize MapDir to working directory
    MapDir = NWMDir;

    //Read Tileset info from INI file.  If no INI file exists, create default version
    TilesetNames = new TStringList();
    for (int i=0; i<TLAYER; ++i) {
        TilesetFiles[i] = new TStringList();
        DrawModes[i] = new TStringList();
    }

    FILE *INIFile;
    if ((INIFile = fopen("NWMAP.INI", "rt")) == NULL) {
        if ((INIFile = fopen("NWMAP.INI", "wt")) == NULL) {
            Application->MessageBox("Cannot create default INI file.", NULL, MB_OK);
            Close();
        } else {
            fputs("City\n", INIFile);
            fputs("tilesets\\outdoor_bases.bmp\n", INIFile);
            fputs("tilesets\\city_layer.bmp\n", INIFile);
            fputs("null\n", INIFile);
            fputs("null\n", INIFile);
            fputs("null\n", INIFile);

            fputs("Dungeon\n", INIFile);
            fputs("tilesets\\indoor_bases.bmp\n", INIFile);
            fputs("tilesets\\indoor_layer.bmp\n", INIFile);
            fputs("null\n", INIFile);
            fputs("null\n", INIFile);
            fputs("null\n", INIFile);
/*
            fputs("Grasslands\n", INIFile);
            fputs("tilesets\\outdoor_bases.bmp\n", INIFile);
            fputs("tilesets\\grass_layer.bmp\n", INIFile);
            fputs("null\n", INIFile);
            fputs("null\n", INIFile);
            fputs("null\n", INIFile);
*/
            TilesetNames->Add("City");
            TilesetFiles[0]->Add("tilesets\\outdoor_bases.bmp");
            TilesetFiles[1]->Add("tilesets\\city_layer.bmp");
            TilesetFiles[2]->Add("null");
            TilesetFiles[3]->Add("null");
            TilesetFiles[4]->Add("null");
            TMenuItem *newItem1 = new TMenuItem(File1);
            newItem1->Caption = "New City";
            newItem1->OnClick = NewClick;
            newItem1->Name = "Tileset0";
            File1->Insert(1, newItem1);

            TilesetNames->Add("Dungeon");
            TilesetFiles[0]->Add("tilesets\\indoor_bases.bmp");
            TilesetFiles[1]->Add("tilesets\\indoor_layer.bmp");
            TilesetFiles[2]->Add("null");
            TilesetFiles[3]->Add("null");
            TilesetFiles[4]->Add("null");
            TMenuItem *newItem2 = new TMenuItem(File1);
            newItem2->Caption = "New Dungeon";
            newItem2->OnClick = NewClick;
            newItem2->Name = "Tileset1";
            File1->Insert(2, newItem2);
/*
            TilesetNames->Add("Grasslands");
            TilesetFiles[0]->Add("tilesets\\outdoor_bases.bmp");
            TilesetFiles[1]->Add("tilesets\\grass_layer.bmp");
            TilesetFiles[2]->Add("null");
            TilesetFiles[3]->Add("null");
            TilesetFiles[4]->Add("null");
            TMenuItem *newItem3 = new TMenuItem(File1);
            newItem3->Caption = "New Grasslands";
            newItem3->OnClick = NewClick;
            newItem3->Name = "Tileset2";
            File1->Insert(3, newItem3);
*/
        }
    } else {
        char buff[80];
        char *check;

        while (1) {
            //Read a tileset name
            check = fgets(buff, sizeof(buff), INIFile);
            if (check==NULL) break;
            check = strchr(buff, '\n'); //find the \n character...
            *check = '\0';              //...and eat it.
            TilesetNames->Add((String)buff);

            for (int i=0; i<TLAYER; ++i) {
                //Read a tileset filename
                check = fgets(buff, sizeof(buff), INIFile);
                if (check==NULL) break;
                check = strchr(buff, '\n'); //find the \n character...
                *check = '\0';              //...and eat it.

                TilesetFiles[i]->Add((String)buff);

//                //Parse the draw mode number
//                S = ((String)buff).SubString(0,1);
//                try {
//                    UseModes[i][TilesetNames->Count-1] = S.ToInt();
//                    //reset UseModes if the current layer is unused.
//                    if (TilesetFiles[i]->Strings[TilesetNames->Count-1] == "null") {
//                        UseModes[i][TilesetNames->Count-1] = -1;
//                    }
//                } catch (...) {
//                    Application->MessageBox("Nonsense detected in NWMAP.INI!  Delete it and restart NWMap.", NULL, MB_OK);
//                    UseModes[i][TilesetNames->Count-1] = -1;
//                }
            }

            TMenuItem *newItem = new TMenuItem(File1);
            newItem->Caption = "New " + TilesetNames->Strings[TilesetNames->Count - 1];
            newItem->OnClick = NewClick;
            newItem->Name = "Tileset" + (String)(TilesetNames->Count - 1);
            File1->Insert(TilesetNames->Count, newItem);
        }
    }

    fclose(INIFile);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCloseQuery(TObject *Sender, bool &CanClose)
{
    bool goSave = false;
    CanClose = true;

    if (MapChanged) {
        YesNo->Message->Caption = "Would you like to save your map before exiting?";
        YesNo->YesButton->Caption = "Yes, Save";
        YesNo->NoButton->Caption = "No, Discard";
        if (YesNo->ShowModal()==mrOk) goSave = true;

        if (goSave) {
            Save1Click( Exit1 );
            if (MapChanged) CanClose = false;  // some problem occured trying to save the map...do not exit.
        }

    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
    delete Map;
    delete Tile;
    delete Tile2;
    delete Mask;
    delete Mask2;
    delete SaveTile;
    delete TileMask2;
    delete InvMask;

    for (int i=0; i<TileList->Count; ++i) {
        delete TileList->Items[i];
    }

    for (int i=0; i<SavedStates->Count; ++i) {
        MapState *ms = (MapState *)SavedStates->Items[i];
        delete ms->SavedTileList;
        delete SavedStates->Items[i];
    }

    for (int i=0; i<RedoStates->Count; ++i) {
        MapState *ms = (MapState *)RedoStates->Items[i];
        delete ms->SavedTileList;
        delete RedoStates->Items[i];
    }

    delete SavedStates;
    delete RedoStates;
    delete TileList;
    delete CutTileList;
    delete nwtClipboard;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormPaint(TObject *Sender)
{
    MapBox->Canvas->Draw(0,0,Map);
}



/*********************Block: Scrollbar Functions******************/
void __fastcall TForm1::XScrollChange(TObject *Sender)
{
    XTile0 = int(XScroll->Position*ScrollStep/TileSize);
    drawMap();
    Form1->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::YScrollChange(TObject *Sender)
{
    YTile0 = int(YScroll->Position*ScrollStep/TileSize);
    drawMap();
    Form1->SetFocus();
}
//---------------------------------------------------------------------------


/******************Block: Speed Button Functions*********************/
void __fastcall TForm1::OpenButtonClick(TObject *Sender)
{
    Open1Click(Form1);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SaveButtonClick(TObject *Sender)
{
    Save1Click(Form1);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::PrintButtonClick(TObject *Sender)
{
    Print1Click(Form1);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ZoomInButtonClick(TObject *Sender)
{
    FormKeyPress(Form1, '+');
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ZoomOutButtonClick(TObject *Sender)
{
    FormKeyPress(Form1, '-');
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RedrawButtonClick(TObject *Sender)
{
    drawMap();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::NewButtonClick(TObject *Sender)
{
    bool proceed = true;
    if (MapChanged) {
        YesNo->Message->Caption = "Save Changes to Current Map?";
        YesNo->YesButton->Caption = "Yes, Save";
        YesNo->NoButton->Caption = "Discard Changes";
        if (YesNo->ShowModal()==mrOk) {
            Save1Click( NewButton );
            if (MapChanged) proceed = false; // some problem occurred trying to save the map.
        }
    }

    if (proceed && NewTilesetForm->ShowModal()==mrOk) {
        int i = NewTilesetForm->TilesetList->ItemIndex;

        if (i >= 0 && i < TilesetNames->Count) {
            TilesetForm->LoadTileset(i);
            DoorForm->DoorGeometry();
            TileList->Clear();

            for (int ix=0; ix<NXMAP; ++ix) {
                for (int iy=0; iy<NYMAP; ++iy) {
                    for (int i=0; i<MLAYER; ++i) {
                        TileArray[ix][iy][i] = TilesetForm->SelectedTile[TilesetForm->CurrentLayer];
                        RotArray[ix][iy][i] = 0;
                    }
                }
            }

            drawMap();
            MapChanged = false;
            SaveButton->Enabled = false;
            SavedStates->Clear();
            RedoStates->Clear();
            UndoButton->Enabled = false;
            RedoButton->Enabled = false;
        } else {
            Application->MessageBox("Error: Could not open this Tileset.", NULL, MB_OK);
        }
    }
}
//---------------------------------------------------------------------------

void TForm1::SaveMapState( bool isUndo ) {
    MapState *ms = new MapState;

    for (int ix=0; ix<NXMAP; ++ix) {
        for (int iy=0; iy<NYMAP; ++iy) {
            for (int i=0; i<MLAYER; ++i) {
                ms->SavedTileArray[ix][iy][i]  = TileArray[ix][iy][i];
                ms->SavedRotArray[ix][iy][i] = RotArray[ix][iy][i];
            }
            for (int j=0; j<5; ++j) {
                ms->SavedDoors[ix][iy][j] = Doors[ix][iy][j];
            }
        }
    }

    ms->SavedTileList = new TList;

    for (int i=0; i<TileList->Count; ++i) {
        NWTile *nwt = (NWTile *)TileList->Items[i];
        ms->SavedTileList->Add(nwt);
    }

    if (isUndo) {
        // Add to Undo saved states
        if (SavedStates->Count > MAXSAVED) SavedStates->Delete(0); //Remove oldest entry
        SavedStates->Add(ms);
        RedoButton->Enabled = false;
    } else {
        // Add to Redo saved states
        if (RedoStates->Count > MAXSAVED) RedoStates->Delete(0); //Remove oldest entry
        RedoStates->Add(ms);
    }

    UndoButton->Enabled = true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::UndoButtonClick(TObject *Sender)
{
    SaveMapState(false); // Save the state to the Redo list

    MapState *ms = (MapState *)SavedStates->Items[SavedStates->Count-1]; // grab the most recent state

    for (int ix=0; ix<NXMAP; ++ix) {
        for (int iy=0; iy<NYMAP; ++iy) {
            for (int i=0; i<MLAYER; ++i) {
                TileArray[ix][iy][i] = ms->SavedTileArray[ix][iy][i];
                RotArray[ix][iy][i] = ms->SavedRotArray[ix][iy][i];
            }
            for (int j=0; j<5; ++j) {
                Doors[ix][iy][j] = ms->SavedDoors[ix][iy][j];
            }
        }
    }

    TileList->Clear();

    for (int i=0; i<ms->SavedTileList->Count; ++i) {
        NWTile *nwt = (NWTile *)ms->SavedTileList->Items[i];
        TileList->Add(nwt);
    }

    //Remove the newly replaced entry from SavedStates
    delete ms->SavedTileList;
    SavedStates->Delete(SavedStates->Count-1);

    RedoButton->Enabled = true;
    if (SavedStates->Count==0) UndoButton->Enabled = false;

    drawMap();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RedoButtonClick(TObject *Sender)
{
    SaveMapState(true);
    MapState *ms = (MapState *)RedoStates->Items[RedoStates->Count-1]; // grab the most recent state

    for (int ix=0; ix<NXMAP; ++ix) {
        for (int iy=0; iy<NYMAP; ++iy) {
            for (int i=0; i<MLAYER; ++i) {
                TileArray[ix][iy][i] = ms->SavedTileArray[ix][iy][i];
                RotArray[ix][iy][i] = ms->SavedRotArray[ix][iy][i];
            }
            for (int j=0; j<5; ++j) {
                Doors[ix][iy][j] = ms->SavedDoors[ix][iy][j];
            }
        }
    }

    TileList->Clear();

    for (int i=0; i<ms->SavedTileList->Count; ++i) {
        NWTile *nwt = (NWTile *)ms->SavedTileList->Items[i];
        TileList->Add(nwt);
    }

    //Remove the newly replaced entry from SavedStates
    delete ms->SavedTileList;
    RedoStates->Delete(RedoStates->Count-1);

    RedoButton->Enabled = true;
    if (RedoStates->Count==0) RedoButton->Enabled = false;

    drawMap();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ExportButtonClick(TObject *Sender)
{
    Export1Click( ExportButton );
}
//---------------------------------------------------------------------------


void __fastcall TForm1::SelectButtonClick(TObject *Sender)
{
    CurrentDrawMode = 1;
    Label1->Caption = "Select Region";
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RotLeftButtonClick(TObject *Sender)
{
    FormKeyPress( this, ',' );    
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RotRightButtonClick(TObject *Sender)
{
    FormKeyPress( this, '.' );    
}
//---------------------------------------------------------------------------


