/***************************************************
 *                                                 *
 *   NWMap v. 1.1                                  *
 *   Copyright 2001, by Jason Harris               *
 *   http://nwmap.nwnonline.net/                   *
 *   nwmap@hotmail.com                             *
 *   jharris@30doradus.org                         *
 *                                                 *
 ***************************************************/
//---------------------------------------------------------------------------
#ifndef NWMapMainH
#define NWMapMainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>
#include "NWConst.h"
#include "NWTile.h"
#include <Dialogs.hpp>
#include <Buttons.hpp>
#include <ComCtrls.hpp>
#include <Printers.hpp>
//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE-managed Components
    TLabel *XTile;
    TLabel *YTile;
    TMainMenu *MainMenu1;
    TMenuItem *File1;
    TMenuItem *Exit1;
    TMenuItem *N1;
    TMenuItem *Print1;
    TMenuItem *SaveAs1;
    TMenuItem *Save1;
    TMenuItem *Open1;
    TMenuItem *Help1;
    TMenuItem *About1;
    TScrollBar *XScroll;
    TScrollBar *YScroll;
    TPaintBox *MapBox;
    TSaveDialog *SaveDialog;
    TOpenDialog *OpenDialog;
    TMenuItem *View1;
    TMenuItem *TilesetSizeItem;
    TMenuItem *N3;
    TMenuItem *AddTileset;
    TMenuItem *Commands1;
    TMenuItem *ViewDoors;
    TMenuItem *N5;
    TMenuItem *ViewLabels;
    TPanel *FilePanel;
    TSpeedButton *NewButton;
    TSpeedButton *OpenButton;
    TSpeedButton *SaveButton;
    TSpeedButton *PrintButton;
    TPanel *ZoomPanelPanel;
    TSpeedButton *ZoomInButton;
    TSpeedButton *ZoomOutButton;
    TPanel *SelectPanel;
    TSpeedButton *SelectButton;
    TPopupMenu *MapMenu;
    TMenuItem *DescItem;
    TMenuItem *CutDesc;
    TMenuItem *CopyDesc;
    TMenuItem *PasteDesc;
    TMenuItem *N2;
    TMenuItem *DoorItem;
    TMenuItem *N4;
    TMenuItem *CutRegion;
    TMenuItem *CopyRegion;
    TMenuItem *PasteRegion;
    TMenuItem *N6;
    TMenuItem *LRotate;
    TMenuItem *RRotate;
    TPanel *UndoPanel;
    TLabel *Label1;
    TSpeedButton *UndoButton;
    TSpeedButton *RedoButton;
    TMenuItem *Export1;
    TSpeedButton *ExportButton;
    TMenuItem *ViewGrid;
    TPanel *RefreshPanel;
    TSpeedButton *RedrawButton;
    TPanel *PreviewPanel;
    TImage *PreviewImage;
    TSpeedButton *RotRightButton;
    TSpeedButton *RotLeftButton;
    void __fastcall FormPaint(TObject *Sender);
    void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
    void __fastcall MapBoxMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
    void __fastcall Exit1Click(TObject *Sender);
    void __fastcall FormCreate(TObject *Sender);
    void __fastcall XScrollChange(TObject *Sender);
    void __fastcall YScrollChange(TObject *Sender);
    void __fastcall FormKeyPress(TObject *Sender, char &Key);
    void __fastcall MapBoxMouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
    void __fastcall NewClick(TObject *Sender);
    void __fastcall Save1Click(TObject *Sender);
    void __fastcall Open1Click(TObject *Sender);
    void __fastcall About1Click(TObject *Sender);
    void __fastcall MapBoxMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
    void __fastcall Print1Click(TObject *Sender);
    void __fastcall DescItemClick(TObject *Sender);
    void __fastcall CutDescClick(TObject *Sender);
    void __fastcall CopyDescClick(TObject *Sender);
    void __fastcall PasteDescClick(TObject *Sender);
    void __fastcall TilesetSizeItemClick(TObject *Sender);
    void __fastcall AddTilesetClick(TObject *Sender);
    void __fastcall OpenButtonClick(TObject *Sender);
    void __fastcall SaveButtonClick(TObject *Sender);
    void __fastcall PrintButtonClick(TObject *Sender);
    void __fastcall ZoomInButtonClick(TObject *Sender);
    void __fastcall ZoomOutButtonClick(TObject *Sender);
    void __fastcall RedrawButtonClick(TObject *Sender);
    void __fastcall NewButtonClick(TObject *Sender);
    void __fastcall Commands1Click(TObject *Sender);
    void __fastcall RotateClick(TObject *Sender);
    void __fastcall CutRegionClick(TObject *Sender);
    void __fastcall PasteRegionClick(TObject *Sender);
    void __fastcall DoorItemClick(TObject *Sender);
    void __fastcall FormKeyUp(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall ViewDoorsClick(TObject *Sender);
    void __fastcall ViewLabelsClick(TObject *Sender);
    void __fastcall UndoButtonClick(TObject *Sender);
    void __fastcall RedoButtonClick(TObject *Sender);
    void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
    void __fastcall Export1Click(TObject *Sender);
    void __fastcall ExportButtonClick(TObject *Sender);
    void __fastcall ViewGridClick(TObject *Sender);
    void __fastcall SelectButtonClick(TObject *Sender);
    void __fastcall RotLeftButtonClick(TObject *Sender);
    void __fastcall RotRightButtonClick(TObject *Sender);
    void __fastcall MapBoxDblClick(TObject *Sender);
private:	// User declarations
    TRect MBRect, RubberRect, TileRect, SelectRect, MapRect;
    Graphics::TBitmap *Map, *Tile2, *Mask, *Mask2, *SaveTile;
    Graphics::TBitmap *TileMask, *TileMask2, *InvMask;
    TFileName SaveFileName;
    void LoadTileset(int iset);
    void TForm1::slideMap(int dx, int dy);
    void TForm1::drawCursor(int X, int Y);
    void TForm1::drawLabels(int iStart, int iEnd);
    void TForm1::drawBox(int X1, int Y1, int X2, int Y2);
    bool TForm1::RectWithin(TRect r1, TRect r2);
    float Zoom;
    int  TForm1::printLine(TPrinter *pr, int X, int l, int lh, int lpp, String s);
    int TileSize;
    int X1, Y1, X2, Y2;
    int X0, Y0, XTile0, YTile0;
    int OldTileX, OldTileY, LastTileX, LastTileY;
    int ScrollStep;
    int dx[4],dy[4],val[4];
    bool MouseDown, MapChanged;
    TColor c;
    struct TileInfo {
        int X, Y, Tile[MLAYER], Rot[MLAYER], Doors[5];
        int iTile;
    };

public:		// User declarations
    __fastcall TForm1(TComponent* Owner);
    void TForm1::drawMap();
    void TForm1::drawTile(int TileX, int TileY);
    void SnakeDraw(void);
    void BlobDraw(void);
    void TileMorph(int x, int y);
    void TForm1::SaveMapState( bool isUndo );
    void TForm1::TransDraw( Graphics::TBitmap *base, Graphics::TBitmap *top );
    void TForm1::updateTile( int iset, int ix, int iy, int t, int r );
    Graphics::TBitmap *Tile;
    TList *TileList, *CutTileList;
    TList *SavedStates, *RedoStates;
    TStringList *TilesetNames, *TilesetFiles[TLAYER], *DrawModes[TLAYER];
    NWTile *nwtClipboard;
    int nmLayer, CurrentLayer, CurrentTileX, CurrentTileY, CurrentDrawMode;
    int TileArray[NXMAP][NYMAP][MLAYER], RotArray[NXMAP][NYMAP][MLAYER];
    int LocID[NMAP], CurrentTile, CurrentTileIndex;
    int RectX1, RectX2, RectY1, RectY2;
    int Doors[NXMAP][NYMAP][5];
//    int SGroup[5][NSGROUP], SGroupFlag[5][NSGROUP];
//    int MorphTile[5][16], MorphRotTile[5][16];
//    int UseModes[TLAYER][10];
    String MapName;
    AnsiString NWMDir, MapDir;
    bool RegionSelected, SnakeMode, OneLayerMode;
    bool WantDoors, WantLabels;
    struct MapState {
        int SavedTileArray[NXMAP][NYMAP][MLAYER], SavedRotArray[NXMAP][NYMAP][MLAYER];
        int SavedDoors[NXMAP][NYMAP][5];
        TList *SavedTileList;
    };

};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
