/***************************************************
 *                                                 *
 *   NWMap v. 1.1                                  *
 *   Copyright 2001, by Jason Harris               *
 *   http://nwmap.nwnonline.net/                   *
 *   nwmap@hotmail.com                             *
 *   jharris@30doradus.org                         *
 *                                                 *
 ***************************************************/
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include <fstream.h>
#include <stdio.h>

#include "NWMenuFuncs.h"
#include "NWMapMain.h"
#include "NWAboutMain.h"
#include "TilesetFormMain.h"
#include "TileDescMain.h"
#include "DoorFormMain.h"
#include "AddTilesetFormMain.h"
#include "CommandsFormMain.h"
#include "YesNoMain.h"
#include "GetMapNameMain.h"
#include "NWTile.h"
#include "NWObject.h"
#include "NWNPC.h"
#include "NWCreature.h"
#include "NWItem.h"
#include "NWEvent.h"
#include "NWPortal.h"
#include "PrintConfigMain.h"

#pragma package(smart_init)
//---------------------------------------------------------------------------
//
//  Event handlers for main menu items, including file open/save, and printing
//
//---------------------------------------------------------------------------

void __fastcall TForm1::Commands1Click(TObject *Sender)
{
    CommandsForm->Show();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::About1Click(TObject *Sender)
{
    NWAbout->Left = Form1->Left + 200;
    NWAbout->Top  = Form1->Top  + 200;
    NWAbout->ShowModal();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::TilesetSizeItemClick(TObject *Sender)
{
    TilesetSizeItem->Checked = !TilesetSizeItem->Checked;
    if (TilesetSizeItem->Checked) TilesetForm->SizeFactor = 2;
    else TilesetForm->SizeFactor = 1;

    TilesetForm->FormShow(Form1);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::AddTilesetClick(TObject *Sender)
{
    if (AddTilesetForm->ShowModal() == mrOk) {
        if (AddTilesetForm->FileName0Text->Text == "") { AddTilesetForm->FileName0Text->Text = "null"; }
        if (AddTilesetForm->FileName1Text->Text == "") { AddTilesetForm->FileName1Text->Text = "null"; }
        if (AddTilesetForm->FileName2Text->Text == "") { AddTilesetForm->FileName2Text->Text = "null"; }
        if (AddTilesetForm->FileName3Text->Text == "") { AddTilesetForm->FileName3Text->Text = "null"; }
        if (AddTilesetForm->FileName4Text->Text == "") { AddTilesetForm->FileName4Text->Text = "null"; }

        TilesetNames->Add(AddTilesetForm->NameText->Text);
        TilesetFiles[0]->Add(AddTilesetForm->FileName0Text->Text);
        TilesetFiles[1]->Add(AddTilesetForm->FileName1Text->Text);
        TilesetFiles[2]->Add(AddTilesetForm->FileName2Text->Text);
        TilesetFiles[3]->Add(AddTilesetForm->FileName3Text->Text);
        TilesetFiles[4]->Add(AddTilesetForm->FileName4Text->Text);

        TMenuItem *newItem = new TMenuItem(Form1);
        newItem->Caption = "New " + TilesetNames->Strings[TilesetNames->Count - 1];
        newItem->OnClick = NewClick;
        newItem->Name = "Tileset" + (String)(TilesetNames->Count - 1);
        File1->Insert(TilesetNames->Count, newItem);

        //Reset AddTilesetForm fields
        AddTilesetForm->NameText->Text = "";
        AddTilesetForm->FileName0Text->Text = "";
        AddTilesetForm->FileName1Text->Text = "";
        AddTilesetForm->FileName2Text->Text = "";
        AddTilesetForm->FileName3Text->Text = "";
        AddTilesetForm->FileName4Text->Text = "";

        SetCurrentDir(NWMDir); // Make sure INI file gets saved in the NWMap directory

        FILE *INIFile;
        if ((INIFile = fopen("NWMAP.INI", "at")) == NULL) {
            Application->MessageBox("Error: Could not append INI file!", NULL, MB_OK);
        } else {
            String sbuff = TilesetNames->Strings[TilesetNames->Count - 1] + "\n";
            fputs(sbuff.c_str(), INIFile);
            sbuff = TilesetFiles[0]->Strings[TilesetFiles[0]->Count - 1] + "\n";
            fputs(sbuff.c_str(), INIFile);
            sbuff = TilesetFiles[1]->Strings[TilesetFiles[1]->Count - 1] + "\n";
            fputs(sbuff.c_str(), INIFile);
            sbuff = TilesetFiles[2]->Strings[TilesetFiles[2]->Count - 1] + "\n";
            fputs(sbuff.c_str(), INIFile);
            sbuff = TilesetFiles[3]->Strings[TilesetFiles[3]->Count - 1] + "\n";
            fputs(sbuff.c_str(), INIFile);
            sbuff = TilesetFiles[4]->Strings[TilesetFiles[4]->Count - 1] + "\n";
            fputs(sbuff.c_str(), INIFile);
        }

        fclose(INIFile);
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Exit1Click(TObject *Sender)
{
    Close();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::NewClick(TObject *Sender)
{
    bool proceed = true;

    if (MapChanged) {
        YesNo->Message->Caption = "Save Changes to Current Map?";
        YesNo->YesButton->Caption = "Yes, Save";
        YesNo->NoButton->Caption = "Discard Changes";
        if (YesNo->ShowModal()==mrOk) {
            Save1Click( Form1 );
            if (MapChanged) proceed = false;  // some problem saving map.
        }
    }

    if (proceed) {
        Form1->Caption = "NWMap";
        SaveFileName = ""; //Next time "Save" is pressed, force "Save As..."
        int iset=-1;
        for (int i=0; i<TilesetNames->Count; ++i) {
            String testName = "Tileset" + (String)i;
            if (((TMenuItem *)Sender)->Name == testName) {
                iset = i;
                break;
            }
        }
        if (iset==-1) Application->MessageBox("Error: could not select this tileset", NULL, MB_OK);

        if (iset > 0) { Form1->DoorItem->Enabled = true; }
        else { Form1->DoorItem->Enabled = false; }

        TilesetForm->LoadTileset(iset);
        DoorForm->DoorGeometry();
        TileList->Clear();

        for (int iLayer=0; iLayer<nmLayer; ++iLayer) {
            for (int ix=0; ix<NXMAP; ++ix) {
                for (int iy=0; iy<NYMAP; ++iy) {
                    TileArray[ix][iy][iLayer] = 0;
                    if (iLayer==1) TileArray[ix][iy][iLayer] = NTILES - 1;
                    RotArray[ix][iy][iLayer] = 0;

                    for (int i=0; i<5; ++i) {
                        Doors[ix][iy][i] = 0;
                    }
                }
            }
        }
        drawMap();
        MapChanged = false;
        SaveButton->Enabled = false;
        SavedStates->Clear();
        RedoStates->Clear();
        UndoButton->Enabled = false;
        RedoButton->Enabled = false;
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Save1Click(TObject *Sender)
{
    bool proceed = false;

    if (Sender==SaveAs1 || SaveFileName == "") {
        if (GetMapName->ShowModal()==mrOk) {
            MapName = GetMapName->MapName->Text;
            Form1->Caption = "NWMap: " + MapName;

            if (SaveDialog->Execute()) {
                SaveFileName = SaveDialog->FileName;
                proceed = true;
            }
        }
    } else {
        if (MapName=="") {
            if (GetMapName->ShowModal()==mrOk) {
                MapName = GetMapName->MapName->Text;
                Form1->Caption = "NWMap: " + MapName;
                proceed = true;
            }
        } else {
            proceed = true;
        }
    }

    if (proceed) {
        ofstream SaveFile(SaveFileName.c_str());

        if (SaveFile.bad()) {
            Application->MessageBox("Cannot use File.", NULL, MB_OK);
        } else {
            SaveFile << MapName.c_str() << "\n"; // write map name.
            SaveFile << TilesetForm->iset << "\n"; // write the tileset ID number

            for (int ix=0; ix<NXMAP; ++ix) {  // write Tile IDs, rotational states
                for (int iy=0; iy<NYMAP; ++iy) {
                    int sum = 0;
                    for (int i=0; i<5; ++i) sum += Doors[ix][iy][i];

                    for (int i=0; i<MLAYER; ++i) {
                        SaveFile << TileArray[ix][iy][i] << " " << RotArray[ix][iy][i] << " ";
                    }

                    if (sum > 0) { //there are doors in this tile
                        SaveFile << " : ";
                        for (int i=0; i<5; ++i) SaveFile << Doors[ix][iy][i] << " ";
                    }
                    SaveFile << "\n";
                }
            }

            // Next, write out the tile attributes.  MapTile number, Name, text description,
            // and information about the NPCs, creatures, items, events, and portals in the tile
            for (int i=0; i<TileList->Count; ++i) { // Loop through described tiles
                NWTile *nwt = (NWTile *)TileList->Items[i];
                SaveFile << nwt->iTile << "\n"; // MapTile number
                SaveFile << nwt->Name.c_str() << "\n"; //Tile's short name

                // Text description
                for (int j=0; j < nwt->Text->Count; ++j) {
                    SaveFile << nwt->Text->Strings[j].c_str() << "\n";
                }
                SaveFile << "...\n"; // End-of-text marker

                // NPCs
                if (nwt->NPCList->Count) SaveFile << "NPCs:\n";
                for (int j=0; j< nwt->NPCList->Count; ++j) {
                    NWNPC *thisNPC = (NWNPC *)nwt->NPCList->Items[j];
                    SaveFile << thisNPC->Name.c_str() << "\n";
                    SaveFile << thisNPC->Align.c_str() << "\n";
                    SaveFile << thisNPC->Race.c_str() << "\n";
                    SaveFile << thisNPC->Class.c_str() << "\n";
                    SaveFile << thisNPC->Script.c_str() << "\n";
                    for (int k=0; k< thisNPC->Text->Count; ++k) {
                        SaveFile << thisNPC->Text->Strings[k].c_str() << "\n";
                    }
                    SaveFile << "...\n"; // End-of-text marker
                }

                // Creatures
                if (nwt->CreatureList->Count) SaveFile << "Creatures:\n";
                for (int j=0; j< nwt->CreatureList->Count; ++j) {
                    NWCreature *thisCreature = (NWCreature *)nwt->CreatureList->Items[j];
                    SaveFile << thisCreature->Name.c_str() << "\n";
                    SaveFile << thisCreature->Type.c_str() << "\n";
                    SaveFile << thisCreature->Weapon.c_str() << "\n";
                    SaveFile << thisCreature->Armor.c_str() << "\n";
                    SaveFile << thisCreature->Script.c_str() << "\n";
                    for (int k=0; k< thisCreature->Text->Count; ++k) {
                        SaveFile << thisCreature->Text->Strings[k].c_str() << "\n";
                    }
                    SaveFile << "...\n"; // End-of-text marker
                }

                // Items
                if (nwt->ItemList->Count) SaveFile << "Items:\n";
                for (int j=0; j< nwt->ItemList->Count; ++j) {
                    NWItem *thisItem = (NWItem *)nwt->ItemList->Items[j];
                    SaveFile << thisItem->Name.c_str() << "\n";
                    SaveFile << thisItem->Value.c_str() << "\n";
                    SaveFile << thisItem->Script.c_str() << "\n";
                    SaveFile << thisItem->Takeable << "\n";
                    for (int k=0; k< thisItem->Text->Count; ++k) {
                        SaveFile << thisItem->Text->Strings[k].c_str() << "\n";
                    }
                    SaveFile << "...\n"; // End-of-text marker
                }

                // Events
                if (nwt->EventList->Count) SaveFile << "Events:\n";
                for (int j=0; j< nwt->EventList->Count; ++j) {
                    NWEvent *thisEvent = (NWEvent *)nwt->EventList->Items[j];
                    SaveFile << thisEvent->Name.c_str() << "\n";
                    SaveFile << thisEvent->Location.c_str() << "\n";
                    SaveFile << thisEvent->Trigger.c_str() << "\n";
                    SaveFile << thisEvent->Script.c_str() << "\n";
                    for (int k=0; k< thisEvent->Text->Count; ++k) {
                        SaveFile << thisEvent->Text->Strings[k].c_str() << "\n";
                    }
                    SaveFile << "...\n"; // End-of-text marker
                }

                // Portals
                if (nwt->PortalList->Count) SaveFile << "Portals:\n";
                for (int j=0; j< nwt->PortalList->Count; ++j) {
                    NWPortal *thisPortal = (NWPortal *)nwt->PortalList->Items[j];
                    SaveFile << thisPortal->Name.c_str() << "\n";
                    SaveFile << thisPortal->Location.c_str() << "\n";
                    SaveFile << thisPortal->TargetMap.c_str() << "\n";
                    SaveFile << thisPortal->TargetTile.c_str() << "\n";
                    SaveFile << thisPortal->Restrictions.c_str() << "\n";
                    for (int k=0; k< thisPortal->Text->Count; ++k) {
                        SaveFile << thisPortal->Text->Strings[k].c_str() << "\n";
                    }
                    SaveFile << "...\n"; // End-of-text marker
                }

                SaveFile << ">>>\n"; // End-of-tile marker
            }

            MapChanged = false;
            SaveButton->Enabled = false;
        }

        MapDir = ExtractFileDir( SaveFileName );
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Open1Click(TObject *Sender)
{
    bool proceed = true;

    if (MapChanged) {
        YesNo->Message->Caption = "Save Changes to Current Map?";
        YesNo->YesButton->Caption = "Yes, Save";
        YesNo->NoButton->Caption = "Discard Changes";
        if (YesNo->ShowModal()==mrOk) {
            Save1Click( Form1 );
            if (MapChanged) proceed = false;  // some problem saving map.
        }
    }

    if (proceed) {
        if (OpenDialog->Execute()) {

            SaveFileName = OpenDialog->FileName;
            Form1->Caption = "NWMap: " + SaveFileName;

            ifstream OpenFile(SaveFileName.c_str());

            if (OpenFile.bad()) {
                Application->MessageBox("Cannot open File.", NULL, MB_OK);
            } else {
                int i;
                char buff[80];
                char a;
                String s;
                bool KeepGoing = true;

                //Read first line (could be MapName or Tileset...)
                OpenFile.getline(buff, sizeof(buff));
                s = (String)buff;

                // If the first line is a number, assume old format (no map name)
                if (s=="0" || s=="1" || s=="2" || s=="3" || s=="4" ||
                    s=="5" || s=="6" || s=="7" || s=="8" || s=="9") {
                    TilesetForm->iset = s.ToInt();
                } else {
                    MapName = s;
                    Form1->Caption = "NWMap: " + MapName;
                    OpenFile >> TilesetForm->iset;
                    OpenFile.get(a); //eat \n
                }


                // read in map's tile IDs and rotational states

                OpenFile.getline(buff, sizeof(buff));
                s = String(buff).Trim();

                //Parse first map line (to check for old format)
                String sub;
                bool isOldFormat = false;

                if (s.Pos(":")==0) {
                    sub = s;
                } else {
                    sub = s.SubString(0, s.Pos(":")-1);
                }

                //If the substring is shorter than 12 characters, the map
                //format is the old single-layer; otherwise, it is the multiple layer format.
                if (sub.Length() < 12) {
                    isOldFormat = true;
                    YesNo->Message->Caption = "This map is in single-layer format.  Update it?";
                    YesNo->YesButton->Caption = "Yes, Update";
                    YesNo->NoButton->Caption = "Leave it Alone!";
                    YesNo->ShowModal();
                }

                for (int ix=0; ix<NXMAP; ++ix) {
                    for (int iy=0; iy<NYMAP; ++iy) {
                        if ( ix != 0 || iy != 0 ) { //don't re-read first line!
                            OpenFile.getline(buff, sizeof(buff));
                            s = String(buff).Trim();

                            if (s.Pos(":")==0) {
                                sub = s;
                            } else {
                                sub = s.SubString(0, s.Pos(":")-1);
                            }
                        }

                        if (isOldFormat) {
                            for (int iLayer=0; iLayer<MLAYER; ++iLayer ) {
                                TileArray[ix][iy][iLayer] = 0; //Initialize to defaults
                                RotArray[ix][iy][iLayer] = 0;
                                if (iLayer==1) TileArray[ix][iy][iLayer] = 99;
                            }

                            char *buff = sub.c_str();
                            int t, r;
                            sscanf(buff, "%d %d", &t, &r);
                            updateTile( TilesetForm->iset, ix, iy, t, r );

                        } else {
                            char *buff = sub.c_str();
                            sscanf( buff, "%d %d %d %d %d %d %d %d %d %d",
                                &TileArray[ix][iy][0], &RotArray[ix][iy][0],
                                &TileArray[ix][iy][1], &RotArray[ix][iy][1],
                                &TileArray[ix][iy][2], &RotArray[ix][iy][2],
                                &TileArray[ix][iy][3], &RotArray[ix][iy][3],
                                &TileArray[ix][iy][4], &RotArray[ix][iy][4] );
                        }

                        if (s.Pos(":")!=0) { //read doors info
                            int root = s.Pos(":") + 2; // Start of Doors portion of line
                            Doors[ix][iy][0] = s.SubString(root, 1).ToInt();
                            Doors[ix][iy][1] = s.SubString(root+2, 1).ToInt();
                            Doors[ix][iy][2] = s.SubString(root+4, 1).ToInt();
                            Doors[ix][iy][3] = s.SubString(root+6, 1).ToInt();
                            //Doors[ix][iy][4] = s.SubString(root+8, 1).ToInt();
                            Doors[ix][iy][4] = 0;
                        }
                    }
                }

                // Read in the tile attributes of each described tile
                TStringList *txt = new TStringList();
                TileList->Clear();
                //OpenFile.get(a);

                while (!OpenFile.eof()) {
                    OpenFile >> i; // Map location of current description
                    if (OpenFile.eof()) break;
                    OpenFile.get(a); //eat \n
                    OpenFile.getline(buff, sizeof(buff));
                    //OpenFile.get(a); //eat \n
                    s = (String)buff; // short name for tile

                    while (!OpenFile.eof()) {
                        OpenFile.getline(buff, sizeof(buff));
                        //OpenFile.get(a); //eat \n
                        if (strcmp(buff,"...")==0) break; // Until end-of-text marker
                        if (strcmp(buff,">>>")==0) { // no more attributes for this tile
                            KeepGoing = false;
                            break;
                        }
                        txt->Add((String)buff);
                    }

                    NWTile *nwt = new NWTile();
                    nwt->iTile = i;
                    nwt->Name = s;
                    nwt->Text->AddStrings(txt);
                    txt->Clear();

                    while (!OpenFile.eof() && KeepGoing) {
                        OpenFile.getline(buff, sizeof(buff));
                        if (strcmp(buff,">>>")==0) { // end of attributes for this tile
                            KeepGoing = false;
                            break;
                        }

                        if (strcmp(buff,"NPCs:")==0) {
                            while (!OpenFile.eof()) {
                                OpenFile.getline(buff, sizeof(buff));

                                if (strcmp(buff,">>>")==0) {
                                    KeepGoing = false;
                                    break;
                                }
                                if ((strcmp(buff,"Creatures:")==0) ||
                                    (strcmp(buff,"Items:")==0) ||
                                    (strcmp(buff,"Events:")==0) ||
                                    (strcmp(buff,"Portals:")==0)) {  // until end of NPCs
                                    break;
                                }

                                NWNPC *newNPC = new NWNPC();

                                newNPC->Name = (String)buff;
                                OpenFile.getline(buff, sizeof(buff));
                                newNPC->Align = (String)buff;
                                OpenFile.getline(buff, sizeof(buff));
                                newNPC->Race = (String)buff;
                                OpenFile.getline(buff, sizeof(buff));
                                newNPC->Class = (String)buff;
                                OpenFile.getline(buff, sizeof(buff));
                                newNPC->Script = (String)buff;
                                while (!OpenFile.eof()) {
                                    OpenFile.getline(buff, sizeof(buff));
                                    if (strcmp(buff,"...")==0) break; // Until end-of-text marker
                                    txt->Add((String)buff);
                                }
                                newNPC->Text->AddStrings(txt);
                                txt->Clear();
                                nwt->NPCList->Add(newNPC);
                            }
                        }

                        if (strcmp(buff,"Creatures:")==0) {
                            while (!OpenFile.eof()) {
                                OpenFile.getline(buff, sizeof(buff));

                                if (strcmp(buff,">>>")==0) {
                                    KeepGoing = false;
                                    break;
                                }
                                if ((strcmp(buff,"Items:")==0) ||
                                    (strcmp(buff,"Events:")==0) ||
                                    (strcmp(buff,"Portals:")==0)) {  // until end of Creatures
                                    break;
                                }

                                NWCreature *newCreature = new NWCreature();

                                newCreature->Name = (String)buff;
                                OpenFile.getline(buff, sizeof(buff));
                                newCreature->Type = (String)buff;
                                OpenFile.getline(buff, sizeof(buff));
                                newCreature->Weapon = (String)buff;
                                OpenFile.getline(buff, sizeof(buff));
                                newCreature->Armor = (String)buff;
                                OpenFile.getline(buff, sizeof(buff));
                                newCreature->Script = (String)buff;

                                while (!OpenFile.eof()) {
                                    OpenFile.getline(buff, sizeof(buff));
                                    if (strcmp(buff,"...")==0) break; // Until end-of-text marker
                                    txt->Add((String)buff);
                                }
                                newCreature->Text->AddStrings(txt);
                                txt->Clear();
                                nwt->CreatureList->Add(newCreature);
                            }
                        }

                        if (strcmp(buff,"Items:")==0) {
                            while (!OpenFile.eof()) {
                                OpenFile.getline(buff, sizeof(buff));

                                if (strcmp(buff,">>>")==0) {
                                    KeepGoing = false;
                                    break;
                                }
                                if ((strcmp(buff,"Events:")==0) ||
                                    (strcmp(buff,"Portals:")==0)) {  // until end of Items
                                    break;
                                }

                                NWItem *newItem = new NWItem();

                                newItem->Name = (String)buff;
                                OpenFile.getline(buff, sizeof(buff));
                                newItem->Value = (String)buff;
                                OpenFile.getline(buff, sizeof(buff));
                                newItem->Script = (String)buff;
                                OpenFile.getline(buff, sizeof(buff));
                                newItem->Takeable = (bool)((String)buff).ToInt();
                                while (!OpenFile.eof()) {
                                    OpenFile.getline(buff, sizeof(buff));
                                    if (strcmp(buff,"...")==0) break; // Until end-of-text marker
                                    txt->Add((String)buff);
                                }
                                newItem->Text->AddStrings(txt);
                                txt->Clear();
                                nwt->ItemList->Add(newItem);
                            }
                        }

                        if (strcmp(buff,"Events:")==0) {
                            while (!OpenFile.eof()) {
                                OpenFile.getline(buff, sizeof(buff));

                                if (strcmp(buff,">>>")==0) {
                                    KeepGoing = false;
                                    break;
                                }
                                if (strcmp(buff,"Portals:")==0) {  // until end of Events
                                    break;
                                }

                                NWEvent *newEvent = new NWEvent();

                                newEvent->Name = (String)buff;
                                OpenFile.getline(buff, sizeof(buff));
                                newEvent->Location = (String)buff;
                                OpenFile.getline(buff, sizeof(buff));
                                newEvent->Trigger = (String)buff;
                                OpenFile.getline(buff, sizeof(buff));
                                newEvent->Script = (String)buff;
                                while (!OpenFile.eof()) {
                                    OpenFile.getline(buff, sizeof(buff));
                                    if (strcmp(buff,"...")==0) break; // Until end-of-text marker
                                    txt->Add((String)buff);
                                }
                                newEvent->Text->AddStrings(txt);
                                txt->Clear();
                                nwt->EventList->Add(newEvent);
                            }
                        }

                        if (strcmp(buff,"Portals:")==0) {
                            while (!OpenFile.eof()) {
                                OpenFile.getline(buff, sizeof(buff));

                                if (strcmp(buff,">>>")==0) { // until end of tile description
                                    KeepGoing = false;
                                    break;
                                }

                                NWPortal *newPortal = new NWPortal();

                                newPortal->Name = (String)buff;
                                OpenFile.getline(buff, sizeof(buff));
                                newPortal->Location = (String)buff;
                                OpenFile.getline(buff, sizeof(buff));
                                newPortal->TargetMap = (String)buff;
                                OpenFile.getline(buff, sizeof(buff));
                                newPortal->TargetTile = (String)buff;
                                OpenFile.getline(buff, sizeof(buff));
                                newPortal->Restrictions = (String)buff;
                                while (!OpenFile.eof()) {
                                    OpenFile.getline(buff, sizeof(buff));
                                    if (strcmp(buff,"...")==0) break; // Until end-of-text marker
                                    txt->Add((String)buff);
                                }
                                newPortal->Text->AddStrings(txt);
                                txt->Clear();
                                nwt->PortalList->Add(newPortal);
                            }
                        }
                    }

                    TileList->Add(nwt);
                    KeepGoing = true;
                }

                TilesetForm->LoadTileset(TilesetForm->iset);
                DoorForm->DoorGeometry();

                drawMap();
                MapChanged = false;
                SaveButton->Enabled = false;
                SavedStates->Clear();
                RedoStates->Clear();
                UndoButton->Enabled = false;
                RedoButton->Enabled = false;

                if (isOldFormat) {
                    MapChanged = true;
                    SaveButton->Enabled = true;
                }
            }
        }

        MapDir = ExtractFileDir( SaveFileName );
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Export1Click(TObject *Sender)
{
    bool proceed = true;

    //Reconfigure PrintConfig Dialog
    PrintConfig->Caption = "Export Configuration";
    PrintConfig->PrintImage->Caption = "Export Map Image";
    PrintConfig->PrintText->Caption = "Export Descriptions";
    PrintConfig->Label1->Caption = "Scale image:";
    PrintConfig->PrintImage->Checked = false;
    PrintConfig->PrintText->Checked = false;
    PrintConfig->Label1->Enabled = true;
    PrintConfig->FontSize->Enabled = true;
    PrintConfig->FontSize->Items->Clear();
    PrintConfig->FontSize->Items->Add( "1.00" );
    PrintConfig->FontSize->Items->Add( "0.50" );
    PrintConfig->FontSize->Items->Add( "0.25" );
    PrintConfig->FontSize->Items->Add( "0.10" );
    PrintConfig->FontSize->ItemIndex = 1;

    if (PrintConfig->ShowModal()==mrOk) {

        //*** Exporting Image ***//
        if (PrintConfig->PrintImage->Checked) {
            TSaveDialog *BMPDialog = new TSaveDialog( Form1 );
            BMPDialog->InitialDir = MapDir;
            BMPDialog->DefaultExt = String("BMP");
            BMPDialog->Filter = "Bitmaps|*.BMP|All Files|*.*";
            BMPDialog->Title = "Export Map Image";

            if (BMPDialog->Execute()) {
                TRect PrintRect;
                TFileName BMPFile = BMPDialog->FileName;
                Graphics::TBitmap *ExportImage = new Graphics::TBitmap();
                HDC exportDC = ExportImage->Canvas->Handle;
                SetStretchBltMode( exportDC, COLORONCOLOR );

                float ScaleFactor = 0.5*(PrintConfig->FontSize->Items->Strings[PrintConfig->FontSize->ItemIndex].ToDouble());
                ExportImage->Width  = NXMAP*TILESIZE*ScaleFactor;
                ExportImage->Height = NYMAP*TILESIZE*ScaleFactor;

                if (FileExists(BMPFile)) {
                    YesNo->Message->Caption = "File exists.  Overwrite?";
                    YesNo->YesButton->Caption = "Yes, Overwrite";
                    YesNo->NoButton->Caption = "Cancel Export";
                    if (YesNo->ShowModal()==mrOk) {
                        DeleteFile( BMPFile );
                    } else {
                        proceed = false;
                    }
                }

                if (proceed) {
                    for (int ix=0; ix<NXMAP; ++ix) {
                        for (int iy=0; iy<NYMAP; ++iy) {
                            for (int i=0; i<MLAYER; ++i) {
                                int j=i-1;
                                if (j<0) j=0;
                                if (i==0) {
                                    TilesetForm->getTile(Tile, TileArray[ix][iy][i], RotArray[ix][iy][i], j);
                                } else {
                                    //Don't need to draw BlankTile's
                                    if ((i==1 && TileArray[ix][iy][i] != NTILES - 1) ||
                                        (i>=2 && TileArray[ix][iy][i] !=  0)) {
                                        TilesetForm->getTile(Tile2, TileArray[ix][iy][i], RotArray[ix][iy][i], j);
                                        TransDraw( Tile, Tile2 );
                                    }
                                }
                            }

                            int iTile = iy*NXMAP + ix;
                            NWTile *nwt = NULL;
                            for (int i=0; i<TileList->Count; ++i) {
                                nwt = (NWTile *)TileList->Items[i];
                                if (nwt->iTile == iTile) {
                                    Tile->Canvas->Font->Color = clBlack;
                                    Tile->Canvas->Font->Height = TILESIZE/2;
                                    Tile->Canvas->TextOut(2,2,(String)(i+1));
                                    break;
                                }
                            }

                            DoorForm->drawDoors(ix, iy, Tile->Canvas, 4);
                            PrintRect = Rect(ix*TILESIZE*ScaleFactor, iy*TILESIZE*ScaleFactor, (ix+1)*TILESIZE*ScaleFactor, (iy+1)*TILESIZE*ScaleFactor);
                            TRect TileRect = Rect(0,0, TILESIZE, TILESIZE);
                            if (!ViewGrid->Enabled) {
                                TileRect = Rect(1,1,TILESIZE-1,TILESIZE-1);
                            }

                            ExportImage->Canvas->CopyRect(PrintRect, Tile->Canvas, TileRect);
                            //ExportImage->Canvas->StretchDraw(PrintRect, Tile);
                        }
                    }
                    ExportImage->SaveToFile( BMPFile );
                }
                delete ExportImage;

            }
            delete BMPDialog;
        }

        //*** Exporting Text ***//
        proceed = true;

        if (PrintConfig->PrintText->Checked) {
            TSaveDialog *TXTDialog = new TSaveDialog( Form1 );
            TXTDialog->InitialDir = MapDir;
            TXTDialog->DefaultExt = String("TXT");
            TXTDialog->Filter = "Text Files|*.TXT|All Files|*.*";
            TXTDialog->Title = "Export Map Descriptions";

            if (TXTDialog->Execute()) {
                TFileName TXTFile = TXTDialog->FileName;
                if (FileExists(TXTFile)) {
                    YesNo->Message->Caption = "File exists.  Overwrite?";
                    YesNo->YesButton->Caption = "Yes, Overwrite";
                    YesNo->NoButton->Caption = "Cancel Export";
                    if (YesNo->ShowModal()==mrOk) {
                        DeleteFile( TXTFile );
                    } else {
                        proceed = false;
                    }
                }

                if (proceed) {
                    String line,line2;
                    TStringList *Desc = new TStringList();

                    for (int i=0; i<TileList->Count; ++i) { // Loop through described tiles
                        NWTile *nwt = (NWTile *)TileList->Items[i];
                        line = (String)(i+1) + ":  " + nwt->Name; //Tile ID number and short name
                        line2 = "";
                        for (int i=0; i<line.Length(); ++i) line2 += "_"; // Underline Tile name
                        Desc->Add( line );
                        Desc->Add( line2 );

                        // Text description
                        for (int j=0; j < nwt->Text->Count; ++j) {
                            Desc->Add(nwt->Text->Strings[j]);
                        }
                        Desc->Add(" "); //add blank line

                        // NPCs
                        if (nwt->NPCList->Count) {
                            Desc->Add(" "); //add blank line
                            Desc->Add("   NPCs:");
                            Desc->Add(" "); //add blank line

                            for (int j=0; j< nwt->NPCList->Count; ++j) {
                                NWNPC *thisNPC = (NWNPC *)nwt->NPCList->Items[j];

                                line = "   " + thisNPC->Name + ":  " + thisNPC->Align + "  " + thisNPC->Race + " ";
                                if (thisNPC->Class != "None") { line += thisNPC->Class; }
                                Desc->Add( line );

                                line = "   Script: " + thisNPC->Script;

                                for (int k=0; k< thisNPC->Text->Count; ++k) {
                                    Desc->Add( "      " + thisNPC->Text->Strings[k] );
                                }
                            }
                            Desc->Add(" ");
                        }

                        // Creatures
                        if (nwt->CreatureList->Count) {
                            Desc->Add(" "); //add blank line
                            Desc->Add("   Creatures:");
                            Desc->Add(" "); //add blank line

                            for (int j=0; j< nwt->CreatureList->Count; ++j) {
                                NWCreature *thisCreature = (NWCreature *)nwt->CreatureList->Items[j];
                                line = "   " + thisCreature->Name + ":  "  + thisCreature->Type;
                                Desc->Add( line );
                                if (thisCreature->Weapon != "") {
                                    line = "   Weapon: " + thisCreature->Weapon;
                                    Desc->Add( line );
                                }
                                if (thisCreature->Armor != "") {
                                    line = "   Armor:  " + thisCreature->Armor;
                                    Desc->Add( line );
                                }
                                if (thisCreature->Script != "") {
                                    line = "   Script: " + thisCreature->Script;
                                    Desc->Add( line );
                                }

                                for (int k=0; k< thisCreature->Text->Count; ++k) {
                                    Desc->Add( "      " + thisCreature->Text->Strings[k] );
                                }
                                Desc->Add(" "); //add blank line
                            }
                        }

                        // Items
                        if (nwt->ItemList->Count) {
                            Desc->Add(" "); //add blank line
                            Desc->Add("   Items:");
                            Desc->Add(" "); //add blank line

                            for (int j=0; j< nwt->ItemList->Count; ++j) {
                                NWItem *thisItem = (NWItem *)nwt->ItemList->Items[j];
                                if (thisItem->Value == "") thisItem->Value = "0 gp";
                                line = "   " + thisItem->Name + "  (" + thisItem->Value + ")";
                                Desc->Add( line );
                                if (thisItem->Script != "") {
                                    line = "   Script: " + thisItem->Script;
                                    Desc->Add( line );
                                }
                                for (int k=0; k< thisItem->Text->Count; ++k) {
                                    Desc->Add( "      " + thisItem->Text->Strings[k] );
                                }
                                Desc->Add(" "); //add blank line
                            }
                        }

                        // Events
                        if (nwt->EventList->Count) {
                            Desc->Add(" "); //add blank line
                            Desc->Add("   Events:");
                            Desc->Add(" "); //add blank line

                            for (int j=0; j< nwt->EventList->Count; ++j) {
                                NWEvent *thisEvent = (NWEvent *)nwt->EventList->Items[j];
                                Desc->Add( "   " + thisEvent->Name );
                                line = "   Location: " + thisEvent->Location;
                                Desc->Add( line );
                                line = "   Trigger: " + thisEvent->Trigger;
                                Desc->Add( line );
                                line = "   Script: " + thisEvent->Script;
                                Desc->Add( line );

                                for (int k=0; k< thisEvent->Text->Count; ++k) {
                                    Desc->Add( "      " + thisEvent->Text->Strings[k] );
                                }
                                Desc->Add(" "); //add blank line
                            }
                        }

                        // Portals
                        if (nwt->PortalList->Count) {
                            Desc->Add(" "); //add blank line
                            Desc->Add("   Portals:");
                            Desc->Add(" "); //add blank line

                            for (int j=0; j< nwt->PortalList->Count; ++j) {
                                NWPortal *thisPortal = (NWPortal *)nwt->PortalList->Items[j];
                                Desc->Add( thisPortal->Name );
                                line = "   Location: " + thisPortal->Location;
                                Desc->Add( line );
                                line = "   Target Map: " + thisPortal->TargetMap;
                                Desc->Add( line );
                                line = "   Target Tile: " + thisPortal->TargetTile;
                                Desc->Add( line );
                                line = "   Script: " + thisPortal->Script;
                                Desc->Add( line );

                                for (int k=0; k< thisPortal->Text->Count; ++k) {
                                    Desc->Add( "      " + thisPortal->Text->Strings[k] );
                                }
                                Desc->Add(" "); //add blank line
                            }
                        }
                        line = "__________________________________________________";
                        Desc->Add( line );
                        Desc->Add(" "); //add blank line
                    }

                    Desc->SaveToFile( TXTFile );
                    delete Desc;
                }
            }
            delete TXTDialog;
        }
    }

    //Reset PrintConfig Dialog
    PrintConfig->Caption = "Print Configuration";
    PrintConfig->PrintImage->Caption = "Print Map Image";
    PrintConfig->PrintText->Caption = "Print Descriptions";
    PrintConfig->Label1->Caption = "Font size:";
    PrintConfig->PrintImage->Checked = false;
    PrintConfig->PrintText->Checked = false;
    PrintConfig->Label1->Enabled = false;
    PrintConfig->FontSize->Enabled = false;
    PrintConfig->FontSize->Items->Clear();
    PrintConfig->FontSize->Items->Add( "8" );
    PrintConfig->FontSize->Items->Add( "10" );
    PrintConfig->FontSize->Items->Add( "12" );
    PrintConfig->FontSize->Items->Add( "14" );
    PrintConfig->FontSize->ItemIndex = 1;  // default font size = 10
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Print1Click(TObject *Sender)
{
    if (PrintConfig->ShowModal()==mrOk) {
        TPrinter *lpr = Printer();

        if (PrintConfig->PrintImage->Checked) {
            Graphics::TBitmap *PrintImage = new Graphics::TBitmap();
            HDC printDC = PrintImage->Canvas->Handle;
            SetStretchBltMode( printDC, COLORONCOLOR );

            TRect PrintRect;

            //Print map image
            PrintImage->Width = NXMAP*TILESIZE/2;
            PrintImage->Height = NYMAP*TILESIZE/2;

            for (int ix=0; ix<NXMAP; ++ix) {
                for (int iy=0; iy<NYMAP; ++iy) {
                    for (int i=0; i<MLAYER; ++i) {
                        int j=i-1;
                        if (j<0) j=0;
                        TilesetForm->getTile(Tile, TileArray[ix][iy][i], RotArray[ix][iy][i], j);
                    }

                    int iTile = iy*NXMAP + ix;
                    NWTile *nwt = NULL;
                    for (int i=0; i<TileList->Count; ++i) {
                        nwt = (NWTile *)TileList->Items[i];
                        if (nwt->iTile == iTile) {
                            Tile->Canvas->Font->Color = clBlack;
                            Tile->Canvas->Font->Height = TILESIZE/2;
                            Tile->Canvas->TextOut(2,2,(String)(i+1));
                            break;
                        }
                    }

                    DoorForm->drawDoors(ix, iy, Tile->Canvas, 4);
                    PrintRect = Rect(ix*TILESIZE/2, iy*TILESIZE/2, (ix+1)*TILESIZE/2, (iy+1)*TILESIZE/2);

                    PrintImage->Canvas->CopyRect( PrintRect, Tile->Canvas, TileRect );
                    //PrintImage->Canvas->StretchDraw(PrintRect, Tile);
                }
            }

            if (FileExists("junk.bmp")) { DeleteFile("junk.bmp"); }
            PrintImage->SaveToFile("junk.bmp");
            PrintImage->LoadFromFile("junk.bmp");
            if (FileExists("junk.bmp")) { DeleteFile("junk.bmp"); }

            PrintRect = Rect(50, 50, lpr->PageWidth - 50, lpr->PageWidth - 50);

            lpr->BeginDoc();
            lpr->Canvas->StretchDraw(PrintRect, PrintImage);
            lpr->EndDoc();

            delete PrintImage;
        }

        if (PrintConfig->PrintText->Checked) {
            //Print Tile descriptions
            lpr->BeginDoc();
            lpr->Canvas->Font->Color = clBlack;
            lpr->Canvas->Font->Name = "Times New Roman";
            lpr->Canvas->Font->Size = PrintConfig->FontSize->Text.ToInt(); //font size

            int LMargin=200;
            int LineHeight = lpr->Canvas->TextHeight("W");
            int LinesPerPage = ( lpr->PageHeight / LineHeight ) - 6;  //3-line buffer for top/bottom margin
            int PageLine = 3;
            String line;

            for (int i=0; i<TileList->Count; ++i) { // Loop through described tiles
                NWTile *nwt = (NWTile *)TileList->Items[i];
                line = (String)(i+1) + ":  " + nwt->Name; //Tile ID number and short name

                lpr->Canvas->Font->Style = lpr->Canvas->Font->Style << fsBold;

                lpr->Canvas->TextOut(LMargin, LineHeight*PageLine, line.c_str());
                ++PageLine;
                lpr->Canvas->Font->Style = lpr->Canvas->Font->Style >> fsBold;

                // Text description
                for (int j=0; j < nwt->Text->Count; ++j) {
                    PageLine = printLine(lpr, LMargin, PageLine, LineHeight, LinesPerPage, nwt->Text->Strings[j]);
                }
                ++PageLine; //add blank line

                // NPCs
                if (nwt->NPCList->Count) {
                    ++PageLine; //add blank line
                    lpr->Canvas->Font->Style = lpr->Canvas->Font->Style << fsBold;
                    PageLine = printLine(lpr, LMargin, PageLine, LineHeight, LinesPerPage, "NPCs:");
                    lpr->Canvas->Font->Style = lpr->Canvas->Font->Style >> fsBold;
                    ++PageLine; //add blank line

                    for (int j=0; j< nwt->NPCList->Count; ++j) {
                        NWNPC *thisNPC = (NWNPC *)nwt->NPCList->Items[j];

                        line = thisNPC->Name + ":  " + thisNPC->Align + "  " + thisNPC->Race + " ";
                        if (thisNPC->Class != "None") { line += thisNPC->Class; }
                        PageLine = printLine(lpr, LMargin, PageLine, LineHeight, LinesPerPage, line);

                        line = "Script: " + thisNPC->Script;
                        PageLine = printLine(lpr, LMargin, PageLine, LineHeight, LinesPerPage, line);

                        if (thisNPC->Text->Count) {
                            PageLine = printLine(lpr, LMargin, PageLine, LineHeight, LinesPerPage, "Notes:");
                        }

                        for (int k=0; k< thisNPC->Text->Count; ++k) {
                            PageLine = printLine(lpr, LMargin, PageLine, LineHeight, LinesPerPage, thisNPC->Text->Strings[k]);
                        }
                        ++PageLine; //add blank line
                    }
                }

                // Creatures
                if (nwt->CreatureList->Count) {
                    ++PageLine; //add blank line
                    lpr->Canvas->Font->Style = lpr->Canvas->Font->Style << fsBold;
                    PageLine = printLine(lpr, LMargin, PageLine, LineHeight, LinesPerPage, "Creatures:");
                    lpr->Canvas->Font->Style = lpr->Canvas->Font->Style >> fsBold;
                    ++PageLine; //add blank line

                    for (int j=0; j< nwt->CreatureList->Count; ++j) {
                        NWCreature *thisCreature = (NWCreature *)nwt->CreatureList->Items[j];
                        line = thisCreature->Name + ":  "  + thisCreature->Type;
                        PageLine = printLine(lpr, LMargin, PageLine, LineHeight, LinesPerPage, line);
                        line = "Weapon: " + thisCreature->Weapon;
                        PageLine = printLine(lpr, LMargin, PageLine, LineHeight, LinesPerPage, line);
                        line = "Armor:  " + thisCreature->Armor;
                        PageLine = printLine(lpr, LMargin, PageLine, LineHeight, LinesPerPage, line);
                        line = "Script: " + thisCreature->Script;
                        PageLine = printLine(lpr, LMargin, PageLine, LineHeight, LinesPerPage, line);

                        if (thisCreature->Text->Count) {
                            PageLine = printLine(lpr, LMargin, PageLine, LineHeight, LinesPerPage, "Notes:");
                        }

                        for (int k=0; k< thisCreature->Text->Count; ++k) {
                            PageLine = printLine(lpr, LMargin, PageLine, LineHeight, LinesPerPage, thisCreature->Text->Strings[k]);
                        }
                        ++PageLine; //add blank line
                    }
                }

                // Items
                if (nwt->ItemList->Count) {
                    ++PageLine; //add blank line
                    lpr->Canvas->Font->Style = lpr->Canvas->Font->Style << fsBold;
                    PageLine = printLine(lpr, LMargin, PageLine, LineHeight, LinesPerPage, "Items:");
                    lpr->Canvas->Font->Style = lpr->Canvas->Font->Style >> fsBold;
                    ++PageLine; //add blank line

                    for (int j=0; j< nwt->ItemList->Count; ++j) {
                        NWItem *thisItem = (NWItem *)nwt->ItemList->Items[j];
                        line = thisItem->Name + "  (" + thisItem->Value + ")";
                        PageLine = printLine(lpr, LMargin, PageLine, LineHeight, LinesPerPage, line);
                        line = "Script: " + thisItem->Script;
                        PageLine = printLine(lpr, LMargin, PageLine, LineHeight, LinesPerPage, line);

                        if (thisItem->Text->Count) {
                            PageLine = printLine(lpr, LMargin, PageLine, LineHeight, LinesPerPage, "Notes:");
                        }

                        for (int k=0; k< thisItem->Text->Count; ++k) {
                            PageLine = printLine(lpr, LMargin, PageLine, LineHeight, LinesPerPage, thisItem->Text->Strings[k]);
                        }
                        ++PageLine; //add blank line
                    }
                }

                // Events
                if (nwt->EventList->Count) {
                    ++PageLine; //add blank line
                    lpr->Canvas->Font->Style = lpr->Canvas->Font->Style << fsBold;
                    PageLine = printLine(lpr, LMargin, PageLine, LineHeight, LinesPerPage, "Events:");
                    lpr->Canvas->Font->Style = lpr->Canvas->Font->Style >> fsBold;
                    ++PageLine; //add blank line

                    for (int j=0; j< nwt->EventList->Count; ++j) {
                        NWEvent *thisEvent = (NWEvent *)nwt->EventList->Items[j];
                        PageLine = printLine(lpr, LMargin, PageLine, LineHeight, LinesPerPage, thisEvent->Name);
                        line = "Location: " + thisEvent->Location;
                        PageLine = printLine(lpr, LMargin, PageLine, LineHeight, LinesPerPage, line);
                        line = "Trigger: " + thisEvent->Trigger;
                        PageLine = printLine(lpr, LMargin, PageLine, LineHeight, LinesPerPage, line);
                        line = "Script: " + thisEvent->Script;
                        PageLine = printLine(lpr, LMargin, PageLine, LineHeight, LinesPerPage, line);

                        if (thisEvent->Text->Count) {
                            PageLine = printLine(lpr, LMargin, PageLine, LineHeight, LinesPerPage, "Notes:");
                        }
                        for (int k=0; k< thisEvent->Text->Count; ++k) {
                            PageLine = printLine(lpr, LMargin, PageLine, LineHeight, LinesPerPage, thisEvent->Text->Strings[k]);
                        }
                        ++PageLine; //add blank line
                    }
                }

                // Portals
                if (nwt->PortalList->Count) {
                    ++PageLine; //add blank line
                    lpr->Canvas->Font->Style = lpr->Canvas->Font->Style << fsBold;
                    PageLine = printLine(lpr, LMargin, PageLine, LineHeight, LinesPerPage, "Portals:");
                    lpr->Canvas->Font->Style = lpr->Canvas->Font->Style >> fsBold;
                    ++PageLine; //add blank line

                    for (int j=0; j< nwt->PortalList->Count; ++j) {
                        NWPortal *thisPortal = (NWPortal *)nwt->PortalList->Items[j];
                        line = thisPortal->Name;
                        PageLine = printLine(lpr, LMargin, PageLine, LineHeight, LinesPerPage, line);
                        line = "Location: " + thisPortal->Location;
                        PageLine = printLine(lpr, LMargin, PageLine, LineHeight, LinesPerPage, line);
                        line = "Target Map: " + thisPortal->TargetMap;
                        PageLine = printLine(lpr, LMargin, PageLine, LineHeight, LinesPerPage, line);
                        line = "Target Tile: " + thisPortal->TargetTile;
                        PageLine = printLine(lpr, LMargin, PageLine, LineHeight, LinesPerPage, line);
                        line = "Script: " + thisPortal->Script;
                        PageLine = printLine(lpr, LMargin, PageLine, LineHeight, LinesPerPage, line);

                        if (thisPortal->Text->Count) {
                            PageLine = printLine(lpr, LMargin, PageLine, LineHeight, LinesPerPage, "Notes:");
                        }
                        for (int k=0; k< thisPortal->Text->Count; ++k) {
                            PageLine = printLine(lpr, LMargin, PageLine, LineHeight, LinesPerPage, thisPortal->Text->Strings[k]);
                        }
                    ++PageLine; //add blank line
                    }
                }
                line = "__________________________________________________";
                PageLine = printLine(lpr, LMargin, PageLine, LineHeight, LinesPerPage, line);
                ++PageLine; //add blank line
            }

            lpr->EndDoc();
        }
    }
}

//Line print function
int TForm1::printLine(TPrinter *lpr, int X, int Line, int LineHeight, int LinesPerPage, String s) {
    if (Line > LinesPerPage) {
        lpr->NewPage();
        Line = 3;
    }
    lpr->Canvas->TextOut(X, LineHeight*Line, s.c_str());
    Line++;
    return Line;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ViewDoorsClick(TObject *Sender)
{
    ViewDoors->Checked = !ViewDoors->Checked;
    WantDoors = ViewDoors->Checked;
    drawMap();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ViewLabelsClick(TObject *Sender)
{
    ViewLabels->Checked = !ViewLabels->Checked;
    WantLabels = ViewLabels->Checked;
    drawMap();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ViewGridClick(TObject *Sender)
{
    ViewGrid->Checked = !ViewGrid->Checked;
    if (ViewGrid->Checked) {
        TileRect = Rect(0, 0, TILESIZE, TILESIZE);
    } else {
        TileRect = Rect(1, 1, TILESIZE-1, TILESIZE-1);
    }
    drawMap();
}
//---------------------------------------------------------------------------

void TForm1::updateTile( int iset, int ix, int iy, int t, int r ) {
    for (int iLayer=0; iLayer<nmLayer; ++iLayer ) {
        RotArray[ix][iy][iLayer] = r; //by default, keep the same rotation
    }
    
    if ( iset==0 || iset==4 ) { //using city tileset
        if ( t<5 || (t>=10 && t<15) ) { //small bldgs and roads translate directly to upper layer
            TileArray[ix][iy][2] = t;
        } else if ( t==5 || t==6 ) {
            TileArray[ix][iy][2] = t + 61; //Diagonal bldg edge
        } else if ( t==7 ) { //fountain (change base and upper layer)
            TileArray[ix][iy][2] = 7;
            TileArray[ix][iy][0] = 10;
        //Tile 8 has no counterpart in new version, so leave it as a blanktile
        } else if ( t==9 ) { //tree
            TileArray[ix][iy][2] = 6;
        } else if ( t==15 ) {//roof peak
            TileArray[ix][iy][2] = 65;
        } else if ( t==16 ) {
            TileArray[ix][iy][2] = 63;
        } else if ( t==17 ) { //paved corner
            TileArray[ix][iy][1] = 13;
        } else if ( t==18 ) { //fence straight
            TileArray[ix][iy][2] = 50;
            r += 1;
            if (r>3) r -= 4;
            RotArray[ix][iy][2] = r;
        } else if ( t==19 ) { //farmland corner
            TileArray[ix][iy][1] = 43;
        } else if ( t>=20 && t<25 ) { //walls
            TileArray[ix][iy][2] = t + 10;
        } else if ( t==25 ) { //diagonal roof peak
            TileArray[ix][iy][2] = 64;
        } else if ( t==26 ) { //bldg corner
            TileArray[ix][iy][2] = 61;
            r = r + 1;
            if (r>3) r -= 4;
            RotArray[ix][iy][2] = r;
        } else if ( t==27 ) { //paved corner
            TileArray[ix][iy][1] = 13;
            r = r + 1;
            if (r>3) r -= 4;
            RotArray[ix][iy][1] = r;
        } else if ( t==28 ) { //fence corner
            TileArray[ix][iy][2] = 51;
        } else if ( t==29 ) { //farmland corner
            TileArray[ix][iy][1] = 41;
            r = r + 2;
            if (r>3) r -= 4;
            RotArray[ix][iy][1] = r;
        } else if ( t==30 || t==31 ) {
            TileArray[ix][iy][2] = t + 10;
        } else if ( t==32 ) {
            TileArray[ix][iy][2] = t + 10;
            r = r + 2;
            if (r>3) r -= 4;
            RotArray[ix][iy][2] = r;
        } else if ( t==33 ) {
            TileArray[ix][iy][2] = t + 11;
            r = r + 1;
            if (r>3) r -= 4;
            RotArray[ix][iy][2] = r;
        } else if ( t==34 || t==35 ) { // river/wall inters. or bridge
            TileArray[ix][iy][2] = t + 11;
        } else if ( t==36 ) { //bldg edge
            TileArray[ix][iy][2] = 62;
            r = r + 1;
            if (r>3) r -= 4;
            RotArray[ix][iy][2] = r;
        } else if ( t==37 ) { //paved edge
            TileArray[ix][iy][1] = 12;
            r = r + 1;
            if (r>3) r -= 4;
            RotArray[ix][iy][1] = r;
        } else if ( t==38 ) { //fence T
            TileArray[ix][iy][2] = 52;
        } else if ( t==39 ) { //farmland edge
            TileArray[ix][iy][1] = 42;
        } else if ( t==40 ) { //water
            TileArray[ix][iy][0] = 20;
        } else if ( t==41 ) { //water edge
            TileArray[ix][iy][1] = 22;
        } else if ( t==42 ) { //water corner
            TileArray[ix][iy][1] = 21;
        } else if ( t==43 ) { //water corner 2
            TileArray[ix][iy][1] = 23;
        } else if ( t==44 ) { //river mouth on lake corner
            TileArray[ix][iy][2] = 54;
        } else if ( t==45 ) { //pond
            TileArray[ix][iy][2] = 55;
        } else if ( t==46 ) { //bldg
            TileArray[ix][iy][2] = 60;
        } else if ( t==47 ) { //paved
            TileArray[ix][iy][0] = 10;
        } else if ( t==48 ) { //fence crossed
            TileArray[ix][iy][2] = 53;
        } else if ( t==49 ) { //farmland
            TileArray[ix][iy][0] = 40;
        } else if (( t>=50 && t<54 ) || t==57 ) { //small bldgs
            TileArray[ix][iy][2] = t - 50;
            TileArray[ix][iy][0] = 10;
        } else if ( t==54 ) {
            TileArray[ix][iy][2] = 5;
        } else if ( t==55 || t==56 ) {
            TileArray[ix][iy][2] = t + 21; //Diagonal bldg edge
            TileArray[ix][iy][0] = 10;
        } else if ( t==58 ) {
            TileArray[ix][iy][2] = 36;
        } else if ( t==59 ) {
            TileArray[ix][iy][2] = 35;
            TileArray[ix][iy][0] = 10;
        } else if ( t>=60 && t<64 ) { //paved street
            TileArray[ix][iy][2] = t - 40;
        } else if ( t==64 ) { //paved gate
            TileArray[ix][iy][0] = 10;
            TileArray[ix][iy][2] = 24;
        } else if ( t==65 ) {
            TileArray[ix][iy][2] = 75;
        } else if ( t==66 ) {
            TileArray[ix][iy][2] = 73;
            TileArray[ix][iy][0] = 10;
        } else if ( t==67 ) {
            TileArray[ix][iy][0] = 10;
        } else if ( t==68 ) {
            TileArray[ix][iy][2] = 30;
            TileArray[ix][iy][1] = 12;
            r += 3;
            if (r>3) r -= 4;
            RotArray[ix][iy][1] = r;
        } else if ( t==69 ) {
            TileArray[ix][iy][1] = 12;
            r += 1;
            if (r>3) r -= 4;
            RotArray[ix][iy][1] = r;
        } else if ( t>=70 && t<75 ) {
            TileArray[ix][iy][0] = 10;
            TileArray[ix][iy][2] = t - 40;
        } else if ( t==75 ) {
            TileArray[ix][iy][2] = 74;
        } else if ( t==76 ) {
            TileArray[ix][iy][0] = 10;
            TileArray[ix][iy][2] = 71;
            r += 1;
            if (r>3) r -= 4;
            RotArray[ix][iy][2] = r;
        } else if ( t>=77 && t<80 ) {
            TileArray[ix][iy][0] = 10;
        } else if ( t==80 ) {
            TileArray[ix][iy][1] = 12;
            TileArray[ix][iy][2] = 30;
        } else if ( t==81 ) {
            TileArray[ix][iy][0] = 10;
        } else if ( t==82 ) {
            TileArray[ix][iy][0] = 10;
            TileArray[ix][iy][2] = 7;
        } else if ( t==85 ) {
            TileArray[ix][iy][2] = 24;
            TileArray[ix][iy][1] = 12;
            r += 3;
            if (r>3) r -= 4;
            RotArray[ix][iy][1] = r;
        } else if ( t==86 || t==88 ) {
            TileArray[ix][iy][0] = 10;
            TileArray[ix][iy][2] = 72;
            r += 1;
            if (r>3) r -= 4;
            RotArray[ix][iy][2] = r;
        } else if ( t==87 || ( t>=89 && t<96 ) ) {
            TileArray[ix][iy][0] = 10;
        } else if ( t==96 ) {
            TileArray[ix][iy][0] = 30;
        } else if ( t>=97 && t<100 ) {
            TileArray[ix][iy][0] = 10;
        }
    } else if ( iset==1 || iset==3 ) { //Dungeon Tileset
        if ( t==1 ) {
            TileArray[ix][iy][1] = 13;
        } else if ( t==2 ) {
            TileArray[ix][iy][2] = 12;
        //no counterpart for t==3 (thin wall end), so leave as blanktile
        } else if ( t==4 ) { //pit
            TileArray[ix][iy][0] = 50;
        } else if ( t==5 ) { //pit edge
            TileArray[ix][iy][0] = 50;// just make it a pit...
            r = r + 3;
            if (r > 3) r -= 4;
            RotArray[ix][iy][1] = r;
        } else if ( t==6 ) {
            TileArray[ix][iy][1] = 51;
            r = r + 3;
            if (r > 3) r -= 4;
            RotArray[ix][iy][1] = r;
        } else if ( t==7 ) {
            TileArray[ix][iy][2] = 65;
            TileArray[ix][iy][0] = 50; //pit base
            r = r + 2;
            if (r > 3) r -= 4;
            RotArray[ix][iy][2] = r;
        } else if ( t==8 ) {
            TileArray[ix][iy][1] = 11;
        } else if ( t==9 ) {
            TileArray[ix][iy][1] = 11;
            r = r + 1;
            if (r > 3) r -= 4;
            RotArray[ix][iy][1] = r;
        } else if ( t==10 ) {
            TileArray[ix][iy][0] = 10;
        } else if ( t==11 ) {
            TileArray[ix][iy][2] = 15;
            r = r + 1;
            if (r > 3) r -= 4;
            RotArray[ix][iy][2] = r;
        } else if ( t==12 ) {
            TileArray[ix][iy][2] = 14;
        } else if ( t==13 ) {
            TileArray[ix][iy][0] = 10;
            TileArray[ix][iy][2] = 40;
            r = r + 1;
            if (r > 3) r -= 4;
            RotArray[ix][iy][2] = r;
        } else if ( t==14 ) {
            TileArray[ix][iy][1] = 52;
            TileArray[ix][iy][2] = 55;
            int r1 = r + 3;
            int r2 = r + 1;
            if (r1 > 3) r1 -= 4;
            if (r2 > 3) r2 -= 4;
            RotArray[ix][iy][1] = r1;
            RotArray[ix][iy][2] = r2;
        } else if ( t==15 ) {
            TileArray[ix][iy][2] = 54;
            r += 3;
            if ( r > 3 ) r -= 4;
            RotArray[ix][iy][2] = r;
        } else if ( t==16 ) {
            TileArray[ix][iy][0] = 50; //pit base
            TileArray[ix][iy][2] = 64; //overpass dead end
            r += 3;
            if ( r > 3 ) r -= 4;
            RotArray[ix][iy][2] = r;
        } else if ( t==17 ) {
            TileArray[ix][iy][1] = 12; //pit base
            TileArray[ix][iy][2] = 7; //wall feature
            RotArray[ix][iy][2] = r;
            r += 1;
            if ( r > 3 ) r -= 4;
            RotArray[ix][iy][1] = r;
        } else if ( t==18 ) {
            TileArray[ix][iy][1] = 11;
        } else if ( t==19 ) {
            TileArray[ix][iy][1] = 11;
            r += 1;
            if ( r>3 ) r -= 4;
            RotArray[ix][iy][1] = r;
        } else if ( t==20 ) {
            TileArray[ix][iy][1] = 11;
            r += 1;
            if ( r>3 ) r -= 4;
            RotArray[ix][iy][1] = r;
        } else if ( t==21 ) {
            TileArray[ix][iy][2] = 19;
        } else if ( t==22 ) {
            TileArray[ix][iy][2] = 11;
        } else if ( t==23 ) {
            TileArray[ix][iy][0] = 10;
            TileArray[ix][iy][2] = 41;
        } else if ( t==24 ) {
            TileArray[ix][iy][1] = 53;
            r += 3;
            if ( r>3 ) r -= 4;
            RotArray[ix][iy][1] = r;
        } else if ( t==25 ) { //pit bridge
            TileArray[ix][iy][0] = 50; //pit
            TileArray[ix][iy][2] = 50; //bridge
        } else if ( t==26 ) { //pit overpass
            TileArray[ix][iy][0] = 50; //pit
            TileArray[ix][iy][2] = 60; //overpass
        } else if ( t==27 ) { //circular feature
            TileArray[ix][iy][0] = 10; //floor
            TileArray[ix][iy][2] =  6; //circle
        } else if ( t==28 ) { //wall + pillars
            TileArray[ix][iy][1] = 12; //wall
            TileArray[ix][iy][2] =  3; //pillars
            r += 3;
            if ( r>3 ) r -= 4;
            RotArray[ix][iy][1] = r;
        } else if ( t==29 ) { //wall + pillars
            TileArray[ix][iy][1] = 12; //wall
            TileArray[ix][iy][2] =  3; //pillars
            r += 1;
            if ( r>3 ) r -= 4;
            RotArray[ix][iy][1] = r;
        } else if ( t==30 ) { //wall
            TileArray[ix][iy][1] = 12;
            r += 1;
            if ( r>3 ) r -= 4;
            RotArray[ix][iy][1] = r;
        } else if ( t==31 ) {
            TileArray[ix][iy][1] = 18;
        } else if ( t==32 ) {
            TileArray[ix][iy][2] = 16;
        } else if ( t==33 ) { //thin wall T
            TileArray[ix][iy][0] = 10;
            TileArray[ix][iy][2] = 42;
        } else if ( t==34 ) {
            TileArray[ix][iy][1] = 53;
            r += 3;
            if ( r>3 ) r -= 4;
            RotArray[ix][iy][1] = r;
        } else if ( t==35 ) { //pit bridge T
            TileArray[ix][iy][0] = 50; //pit
            TileArray[ix][iy][2] = 52; //bridge T
        } else if ( t==36 ) { //pit overpass T
            TileArray[ix][iy][0] = 50; //pit
            TileArray[ix][iy][2] = 62; //overpass T
        } else if ( t==37 ) { //small pit feature
            TileArray[ix][iy][0] = 10; //floor
            TileArray[ix][iy][2] =  5; //pit feature
        } else if ( t==38 ) { // 2 small pillars
            TileArray[ix][iy][0] = 10; //floor
            TileArray[ix][iy][2] =  3; //small pillars
        } else if ( t==39 ) { //wall with 4 pillars
            TileArray[ix][iy][1] = 12; //wall
            TileArray[ix][iy][2] =  4; //small pillars
            r += 1;
            if ( r>3 ) r -= 4;
            RotArray[ix][iy][1] = r;
        } else if ( t==40 ) { //hall
            TileArray[ix][iy][2] =  10;
        } else if ( t==41 ) { //hall intersection
            TileArray[ix][iy][2] =  13;
        } else if ( t==42 ) {
            TileArray[ix][iy][2] =  17;
        } else if ( t==43 ) { //thin wall crossing
            TileArray[ix][iy][0] = 10; //floor
            TileArray[ix][iy][2] = 43; //wall crossing
        } else if ( t==44 ) {
            TileArray[ix][iy][1] = 53;
            r += 3;
            if ( r>3 ) r -= 4;
            RotArray[ix][iy][1] = r;
        } else if ( t==45 ) { //pit bridge intersection
            TileArray[ix][iy][0] = 50; //pit
            TileArray[ix][iy][2] = 53; //bridge intersection
        } else if ( t==46 ) { //pit overpass intersection
            TileArray[ix][iy][0] = 50; //pit
            TileArray[ix][iy][2] = 63; //overpass intersection
        } else if ( t==47 ) { //large pillar
            TileArray[ix][iy][0] = 10; //floor
            TileArray[ix][iy][2] =  1; //large pillar
        } else if ( t==48 ) { //2 pillars
            TileArray[ix][iy][0] = 10; //floor
            TileArray[ix][iy][2] =  2; //2 pillars
        } else if ( t==49 ) { // wall + 2 pillars
            TileArray[ix][iy][1] = 12; //wall
            TileArray[ix][iy][2] =  2; //2 pillars
            r += 1;
            if ( r>3 ) r -= 4;
            RotArray[ix][iy][1] = r;
        } else if ( t==50 ) { //portal...no new version, repl with plant :)
            TileArray[ix][iy][0] = 10; //floor
            TileArray[ix][iy][2] =  9; //plant
        } else if ( t==51 ) { //stairs in floor
            TileArray[ix][iy][0] = 10; //floor
            TileArray[ix][iy][2] =  8; //stairs
        } else if ( t==52 ) { //stairs in rock
            TileArray[ix][iy][2] =  8; //stairs
        } else if ( t==53 ) { //thin wall anchor
            TileArray[ix][iy][2] = 44;
        } else if ( t==54 ) {
            TileArray[ix][iy][1] = 53;
            r += 3;
            if ( r>3 ) r -= 4;
            RotArray[ix][iy][1] = r;
        } else if ( t==55 ) { //pit bridge corner
            TileArray[ix][iy][0] = 50; //pit
            TileArray[ix][iy][2] = 51; //bridge corner
            r += 3;
            if ( r>3 ) r -= 4;
            RotArray[ix][iy][2] = r;
        } else if ( t==56 ) { //pit overpass corner
            TileArray[ix][iy][0] = 50; //pit
            TileArray[ix][iy][2] = 61; //overpass corner
            r += 3;
            if ( r>3 ) r -= 4;
            RotArray[ix][iy][2] = r;
        } else if ( t==57 ) { //pit wall
            TileArray[ix][iy][1] = 62;
            r += 2;
            if ( r>3 ) r -= 4;
            RotArray[ix][iy][1] = r;
        } else if ( t==58 ) { //pit wall corner
            TileArray[ix][iy][1] = 61;
            r += 2;
            if ( r>3 ) r -= 4;
            RotArray[ix][iy][1] = r;
        }
    } else if ( iset==2 ) { //grasslands
        if ( t==1 ) {
            TileArray[ix][iy][1] = 31;
            r += 3;
            if ( r>3 ) r -= 4;
            RotArray[ix][iy][1] = r;
        } else if ( t==2 || t==3 ) {
            TileArray[ix][iy][1] = 30 + t;
            RotArray[ix][iy][1] = r;
        } else if ( t==4 ) {
            TileArray[ix][iy][0] = 30;
        } else if ( t>=10 && t<14 ) {
            TileArray[ix][iy][2] = t;
            RotArray[ix][iy][2] = r;
        } else if ( t==14 || t==15 ) {
            TileArray[ix][iy][2] = 46;
            RotArray[ix][iy][2] = r;
        } else if ( t==16 ) {
            TileArray[ix][iy][1] = 22;
            r += 3;
            if ( r>3 ) r -= 4;
            RotArray[ix][iy][1] = r;
        } else if ( t>=20 && t<24 ) {
            TileArray[ix][iy][2] = t;
            RotArray[ix][iy][2] = r;
        } else if ( t==24 ) {
            TileArray[ix][iy][2] = 36;
            RotArray[ix][iy][2] = r;
        } else if ( t==25 ) {
            TileArray[ix][iy][2] = 47;
            RotArray[ix][iy][2] = r;
        } else if ( t==26 ) {
            TileArray[ix][iy][1] = 22;
            r += 3;
            if ( r>3 ) r -= 4;
            RotArray[ix][iy][1] = r;
        } else if ( t>=30 && t<33 ) {
            TileArray[ix][iy][2] = t + 10;
            if ( t==31 ) {
                r += 2;
                if ( r>3 ) r -= 4;
            }
            RotArray[ix][iy][2] = r;
        } else if ( t==33 ) {
            TileArray[ix][iy][2] = 44;
            r += 1;
            if ( r>3 ) r -= 4;
            RotArray[ix][iy][2] = r;
        } else if ( t==34 ) {
            TileArray[ix][iy][2] = 55;
            RotArray[ix][iy][2] = r;
        } else if ( t==40 ) {
            TileArray[ix][iy][0] = 20;
        } else if ( t==41 ) {
            TileArray[ix][iy][1] = 22;
            RotArray[ix][iy][1] = r;
        } else if ( t==42 ) {
            TileArray[ix][iy][1] = 21;
            RotArray[ix][iy][1] = r;
        } else if ( t==43 ) {
            TileArray[ix][iy][1] = 23;
            RotArray[ix][iy][1] = r;
        } else if ( t==44 ) {
            TileArray[ix][iy][2] = 54;
            RotArray[ix][iy][2] = r;
        } else if ( t>=60 && t<63 ) {
            TileArray[ix][iy][2] = 6;
            RotArray[ix][iy][2] = r;
        } else if ( t==63 ) {
            TileArray[ix][iy][2] = 5;
            RotArray[ix][iy][2] = r;
        } else if ( t>=80 && t<84 ) {
            TileArray[ix][iy][2] = t - 30;
            if ( t==80 ) {
                r += 1;
                if ( r>3 ) r -= 4;
            } else if ( t==82 ) {
                r += 3;
                if ( r>3 ) r -= 4;
            }
            RotArray[ix][iy][2] = r;
        }
    }
}

