/***************************************************
 *                                                 *
 *   NWMap v. 1.1                                  *
 *   Copyright 2001, by Jason Harris               *
 *   http://nwmap.nwnonline.net/                   *
 *   nwmap@hotmail.com                             *
 *   jharris@30doradus.org                         *
 *                                                 *
 ***************************************************/
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "NWTile.h"
#include "NWNPC.h"
#include "NWCreature.h"
#include "NWItem.h"
#include "NWEvent.h"
#include "NWPortal.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)

NWTile::NWTile() {
    Text         = new TStringList();
    NPCList      = new TList();
    CreatureList = new TList();
    ItemList     = new TList();
    EventList    = new TList();
    PortalList   = new TList();
}

NWTile::NWTile(NWTile *nwt) {
    Text         = new TStringList();
    NPCList      = new TList();
    CreatureList = new TList();
    ItemList     = new TList();
    EventList    = new TList();
    PortalList   = new TList();

    iTile = nwt->iTile;
    Name = nwt->Name;

    for (int i=0; i < nwt->Text->Count; ++i) {
        String s = nwt->Text->Strings[i];
        Text->Add(s);
    }

    for (int i=0; i < nwt->NPCList->Count; ++i) {
        NPCList->Add((NWNPC *)nwt->NPCList->Items[i]);
    }
    for (int i=0; i < nwt->CreatureList->Count; ++i) {
        CreatureList->Add((NWCreature *)nwt->CreatureList->Items[i]);
    }
    for (int i=0; i < nwt->ItemList->Count; ++i) {
        ItemList->Add((NWItem *)nwt->ItemList->Items[i]);
    }
    for (int i=0; i < nwt->EventList->Count; ++i) {
        EventList->Add((NWEvent *)nwt->EventList->Items[i]);
    }
    for (int i=0; i < nwt->PortalList->Count; ++i) {
        PortalList->Add((NWPortal *)nwt->PortalList->Items[i]);
    }
}

NWTile::~NWTile() {
    delete Text;
    for (int i=0; i < NPCList->Count; ++i) {
        delete NPCList->Items[i];
    }
    for (int i=0; i < CreatureList->Count; ++i) {
        delete CreatureList->Items[i];
    }
    for (int i=0; i < ItemList->Count; ++i) {
        delete ItemList->Items[i];
    }
    for (int i=0; i < EventList->Count; ++i) {
        delete EventList->Items[i];
    }
    for (int i=0; i < PortalList->Count; ++i) {
        delete PortalList->Items[i];
    }

    delete NPCList;
    delete CreatureList;
    delete ItemList;
    delete EventList;
    delete PortalList;
}

void NWTile::AddNPCs(TList *NPCs) {
    for (int i=0; i < NPCs->Count; ++i) {
        NPCList->Add((NWNPC *)NPCs->Items[i]);
    }
}

void NWTile::AddCreatures(TList *Creatures) {
    for (int i=0; i < Creatures->Count; ++i) {
        CreatureList->Add((NWCreature *)Creatures->Items[i]);
    }
}

void NWTile::AddItems(TList *Stuff) {
    for (int i=0; i < Stuff->Count; ++i) {
        ItemList->Add((NWItem *)Stuff->Items[i]);
    }
}

void NWTile::AddEvents(TList *Events) {
    for (int i=0; i < Events->Count; ++i) {
        EventList->Add((NWEvent *)Events->Items[i]);
    }
}

void NWTile::AddPortals(TList *Portals) {
    for (int i=0; i < Portals->Count; ++i) {
        PortalList->Add((NWPortal *)Portals->Items[i]);
    }
}



