/***************************************************
 *                                                 *
 *   NWMap v. 1.1                                  *
 *   Copyright 2001, by Jason Harris               *
 *   http://nwmap.nwnonline.net/                   *
 *   nwmap@hotmail.com                             *
 *   jharris@30doradus.org                         *
 *                                                 *
 ***************************************************/
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "TileDescMain.h"
#include "TilesetFormMain.h"
#include "ChangeIDFormMain.h"
#include "NWMapMain.h"
#include "NWTile.h"
#include "NWCreature.h"
#include "NWEvent.h"
#include "NWItem.h"
#include "NWNPC.h"
#include "NWObject.h"
#include "NWPortal.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TTileDescForm *TileDescForm;
//---------------------------------------------------------------------------
__fastcall TTileDescForm::TTileDescForm(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------


void __fastcall TTileDescForm::ChangeIDClick(TObject *Sender)
{
    if (ChangeIDForm->ShowModal() == mrOk) {
        if (ChangeIDForm->TileList->ItemIndex != -1) LocID->Text = ChangeIDForm->TileList->ItemIndex + 1;
    }
}
//---------------------------------------------------------------------------
void __fastcall TTileDescForm::FormShow(TObject *Sender)
{
    PageControl1->ActivePage = DescPage;
    TileTextBox->Lines->Clear();
    NPCList->Clear();
    CreatureList->Clear();
    ItemList->Clear();
    EventList->Clear();
    PortalList->Clear();

    int MapTile = Form1->CurrentTile;
    int id = -1;

    //First, determine if this Tile already has a description
    for (int i=0; i<Form1->TileList->Count; ++i) {
        nwt = (NWTile *)Form1->TileList->Items[i];
        if (nwt->iTile == MapTile) {
            id = i;
            break; //found the tile, stop looking
        }
    }

    if (id == -1) { // Current Map Tile has not been described
        TileName->Text = "";
        nwt = new NWTile();
        nwt->iTile = MapTile;
        id = Form1->TileList->Count;
    } else {
        nwt = new NWTile((NWTile *)Form1->TileList->Items[id]); // Copy constructor
    }

    //Render the NWTile attributes in the window controls
    LocID->Text = (String)(id + 1); //convert to 1-based count
    TileName->Text = nwt->Name;
    TileTextBox->Lines->AddStrings(nwt->Text);

    for (int i=0; i < nwt->NPCList->Count; ++i) {
        NPCList->Items->Add(((NWNPC *)nwt->NPCList->Items[i])->Name);
    }

    for (int i=0; i < nwt->CreatureList->Count; ++i) {
        String CreatureName = ((NWCreature *)nwt->CreatureList->Items[i])->Name;
        if (CreatureName=="") {
            CreatureList->Items->Add(((NWCreature *)nwt->CreatureList->Items[i])->Type);
        } else {
            CreatureList->Items->Add(CreatureName);
        }
    }

    for (int i=0; i < nwt->ItemList->Count; ++i) {
        ItemList->Items->Add(((NWItem *)nwt->ItemList->Items[i])->Name);
    }

    for (int i=0; i < nwt->EventList->Count; ++i) {
        EventList->Items->Add(((NWEvent *)nwt->EventList->Items[i])->Name);
    }

    for (int i=0; i < nwt->PortalList->Count; ++i) {
        PortalList->Items->Add(((NWPortal *)nwt->PortalList->Items[i])->Name);
    }
}
//---------------------------------------------------------------------------


/************   Update Components *************/
void __fastcall TTileDescForm::CustomEditExit(TObject *Sender)
{
    if (((TCustomEdit *)Sender)->Modified) {
        int i;

        if (Sender==TileName) {
            nwt->Name = TileName->Text;

        } else if (Sender==TileTextBox) {
            nwt->Text->Clear();
            nwt->Text->AddStrings(TileTextBox->Lines);

        } else if (NPCList->ItemIndex >= 0) {
            i=NPCList->ItemIndex;
            NWNPC *thisNPC = (NWNPC *)nwt->NPCList->Items[i];
            if (Sender==NPCName) {
                thisNPC->Name = NPCName->Text;
                NPCList->Items->Strings[i] = NPCName->Text;
            } else if (Sender==NPCAlign) {
                thisNPC->Align = NPCAlign->Text;
            } else if (Sender==NPCRace) {
                thisNPC->Race = NPCRace->Text;
            } else if (Sender==NPCClass) {
                thisNPC->Class = NPCClass->Text;
            } else if (Sender==NPCScript) {
                thisNPC->Script = NPCScript->Text;
            } else if (Sender==NPCText) {
                thisNPC->Text->Clear();
                thisNPC->Text->AddStrings(NPCText->Lines);
            }

        } else if (CreatureList->ItemIndex >= 0) {
            i=CreatureList->ItemIndex;
            NWCreature *thisCreature = (NWCreature *)nwt->CreatureList->Items[i];
            if (Sender==CreatName) {
                thisCreature->Name = CreatName->Text;
                CreatureList->Items->Strings[i] = CreatName->Text;
            } else if (Sender==CreatType) {
                thisCreature->Type = CreatType->Text;
            } else if (Sender==CreatWeapon) {
                thisCreature->Weapon = CreatWeapon->Text;
            } else if (Sender==CreatArmor) {
                thisCreature->Armor = CreatArmor->Text;
            } else if (Sender==CreatScript) {
                thisCreature->Script = CreatScript->Text;
            } else if (Sender==CreatText) {
                thisCreature->Text->Clear();
                thisCreature->Text->AddStrings(CreatText->Lines);
            }

        } else if (ItemList->ItemIndex >= 0) {
            i=ItemList->ItemIndex;
            NWItem *thisItem = (NWItem *)nwt->ItemList->Items[i];
            if (Sender==ItemName) {
                thisItem->Name = ItemName->Text;
                ItemList->Items->Strings[i] = ItemName->Text;
            } else if (Sender==ItemValue) {
                thisItem->Value = ItemValue->Text;
            } else if (Sender==ItemScript) {
                thisItem->Script = ItemScript->Text;
            } else if (Sender==ItemText) {
                thisItem->Text->Clear();
                thisItem->Text->AddStrings(ItemText->Lines);
            }

        } else if (EventList->ItemIndex >= 0) {
            i=EventList->ItemIndex;
            NWEvent *thisEvent = (NWEvent *)nwt->EventList->Items[i];
            if (Sender==EventName) {
                thisEvent->Name = EventName->Text;
                EventList->Items->Strings[i] = EventName->Text;
            } else if (Sender==EventLocation) {
                thisEvent->Location = EventLocation->Text;
            } else if (Sender==EventTrigger) {
                thisEvent->Trigger = EventTrigger->Text;
            } else if (Sender==EventScript) {
                thisEvent->Script = EventScript->Text;
            } else if (Sender==EventText) {
                thisEvent->Text->Clear();
                thisEvent->Text->AddStrings(EventText->Lines);
            }

        } else if (PortalList->ItemIndex >= 0) {
            i=PortalList->ItemIndex;
            NWPortal *thisPortal = (NWPortal *)nwt->PortalList->Items[i];
            if (Sender==PortalName) {
                thisPortal->Name = PortalName->Text;
                PortalList->Items->Strings[i] = PortalName->Text;
            } else if (Sender==PortalLocation) {
                thisPortal->Location = PortalLocation->Text;
            } else if (Sender==PortalMap) {
                thisPortal->TargetMap = PortalMap->Text;
            } else if (Sender==PortalTile) {
                thisPortal->TargetTile = PortalTile->Text;
            } else if (Sender==PortalLevel) {
                thisPortal->Restrictions = PortalLevel->Text;
            } else if (Sender==PortalText) {
                thisPortal->Text->Clear();
                thisPortal->Text->AddStrings(PortalText->Lines);
            }
        }
    }
}
//---------------------------------------------------------------------------

void __fastcall TTileDescForm::ItemMoveableExit(TObject *Sender)
{
    if (int i=ItemList->ItemIndex >= 0) {
        NWItem *thisItem = (NWItem *)nwt->ItemList->Items[i];
        thisItem->Takeable = ItemMoveable->Checked;
    }
}
//---------------------------------------------------------------------------

void __fastcall TTileDescForm::PageExit(TObject *Sender)
{
    // Unselect Items in List boxes when page is exited.
    if (Sender==NPCPage) NPCClear();
    if (Sender==CreaturePage) CreatClear();
    if (Sender==ItemPage) ItemClear();
    if (Sender==EventPage) EventClear();
    if (Sender==PortalPage) PortalClear();
}
//---------------------------------------------------------------------------


////////Code for the NPC page/////////
void __fastcall TTileDescForm::NPCAddClick(TObject *Sender)
{
    NWNPC *newNPC = new NWNPC();
    newNPC->Name   = NPCName->Text;
    newNPC->Align  = NPCAlign->Text;
    newNPC->Race   = NPCRace->Text;
    newNPC->Class  = NPCClass->Text;
    newNPC->Script = NPCScript->Text;
    newNPC->Text->AddStrings(NPCText->Lines);

    nwt->NPCList->Add(newNPC);
    NPCList->Items->Add(NPCName->Text);
    NPCClear();

    NPCRemove->Enabled = true;
}
//---------------------------------------------------------------------------

void __fastcall TTileDescForm::NPCRemoveClick(TObject *Sender)
{
    nwt->NPCList->Delete(NPCList->ItemIndex);
    NPCList->Items->Delete(NPCList->ItemIndex);
    --NPCList->ItemIndex;
    NPCClear();

    if (NPCList->Items->Count==0) NPCRemove->Enabled = false;
}
//---------------------------------------------------------------------------

void __fastcall TTileDescForm::NPCListClick(TObject *Sender)
{
    //Update Display of NPC attributes to reflect new selection
    NWNPC *thisNPC = (NWNPC *)nwt->NPCList->Items[NPCList->ItemIndex];
    NPCName->Text   = thisNPC->Name;
    NPCAlign->Text  = thisNPC->Align;
    NPCRace->Text   = thisNPC->Race;
    NPCClass->Text  = thisNPC->Class;
    NPCScript->Text = thisNPC->Script;
    NPCText->Lines->Clear();
    NPCText->Lines->AddStrings(thisNPC->Text);
}
//---------------------------------------------------------------------------

void TTileDescForm::NPCClear(void) {
    NPCName->Text   = "";
    NPCAlign->Text  = "";
    NPCRace->Text   = "";
    NPCClass->Text  = "";
    NPCScript->Text = "";
    NPCText->Lines->Clear();
    NPCList->ItemIndex = -1;
}
//---------------------------------------------------------------------------

void __fastcall TTileDescForm::CreatAddClick(TObject *Sender)
{
    NWCreature *newCreature = new NWCreature();
    newCreature->Name   = CreatName->Text;
    newCreature->Type   = CreatType->Text;
    newCreature->Weapon = CreatWeapon->Text;
    newCreature->Armor  = CreatArmor->Text;
    newCreature->Script = CreatScript->Text;
    newCreature->Text->AddStrings(CreatText->Lines);

    nwt->CreatureList->Add(newCreature);
    CreatureList->Items->Add(CreatName->Text);
    CreatClear();

    CreatRemove->Enabled = true;
}
//---------------------------------------------------------------------------

void __fastcall TTileDescForm::CreatRemoveClick(TObject *Sender)
{
    nwt->CreatureList->Delete(CreatureList->ItemIndex);
    CreatureList->Items->Delete(CreatureList->ItemIndex);
    --CreatureList->ItemIndex;
    CreatClear();

    if (CreatureList->Items->Count==0) CreatRemove->Enabled = false;
}
//---------------------------------------------------------------------------

void __fastcall TTileDescForm::CreatureListClick(TObject *Sender)
{
    //Update Display of Creature attributes to reflect new selection
    NWCreature *thisCreature = (NWCreature *)nwt->CreatureList->Items[CreatureList->ItemIndex];
    CreatName->Text   = thisCreature->Name;
    CreatType->Text   = thisCreature->Type;
    CreatWeapon->Text = thisCreature->Weapon;
    CreatArmor->Text  = thisCreature->Armor;
    CreatScript->Text = thisCreature->Script;
    CreatText->Lines->Clear();
    CreatText->Lines->AddStrings(thisCreature->Text);
}
//---------------------------------------------------------------------------

void TTileDescForm::CreatClear(void) {
    CreatName->Text   = "";
    CreatType->Text   = "";
    CreatWeapon->Text = "";
    CreatArmor->Text  = "";
    CreatScript->Text = "";
    CreatText->Lines->Clear();
    CreatureList->ItemIndex = -1;
}
//---------------------------------------------------------------------------

void __fastcall TTileDescForm::ItemAddClick(TObject *Sender)
{
    NWItem *newItem = new NWItem();
    newItem->Name     = ItemName->Text;
    newItem->Value    = ItemValue->Text;
    newItem->Script   = ItemScript->Text;
    newItem->Takeable = ItemMoveable->Checked;
    newItem->Text->AddStrings(ItemText->Lines);

    nwt->ItemList->Add(newItem);
    ItemList->Items->Add(ItemName->Text);
    ItemClear();

    ItemRemove->Enabled = true;
}
//---------------------------------------------------------------------------

void __fastcall TTileDescForm::ItemRemoveClick(TObject *Sender)
{
    nwt->ItemList->Delete(ItemList->ItemIndex);
    ItemList->Items->Delete(ItemList->ItemIndex);
    --ItemList->ItemIndex;
    ItemClear();

    if (ItemList->Items->Count==0) ItemRemove->Enabled = false;
}
//---------------------------------------------------------------------------

void __fastcall TTileDescForm::ItemListClick(TObject *Sender)
{
    //Update Display of Item attributes to reflect new selection
    NWItem *thisItem = (NWItem *)nwt->ItemList->Items[ItemList->ItemIndex];
    ItemName->Text   = thisItem->Name;
    ItemValue->Text  = thisItem->Value;
    ItemScript->Text = thisItem->Script;
    ItemMoveable->Checked = thisItem->Takeable;
    ItemText->Lines->Clear();
    ItemText->Lines->AddStrings(thisItem->Text);
}
//---------------------------------------------------------------------------

void TTileDescForm::ItemClear(void) {
    ItemName->Text   = "";
    ItemValue->Text  = "";
    ItemScript->Text = "";
    ItemMoveable->Checked = true;
    ItemText->Lines->Clear();
    ItemList->ItemIndex = -1;
}
//---------------------------------------------------------------------------

void __fastcall TTileDescForm::EventAddClick(TObject *Sender)
{
    NWEvent *newEvent = new NWEvent();
    newEvent->Name     = EventName->Text;
    newEvent->Location = EventLocation->Text;
    newEvent->Trigger  = EventTrigger->Text;
    newEvent->Script   = EventScript->Text;
    newEvent->Text->AddStrings(EventText->Lines);

    nwt->EventList->Add(newEvent);
    EventList->Items->Add(EventName->Text);
    EventClear();

    EventRemove->Enabled = true;
}
//---------------------------------------------------------------------------

void __fastcall TTileDescForm::EventRemoveClick(TObject *Sender)
{
    nwt->EventList->Delete(EventList->ItemIndex);
    EventList->Items->Delete(EventList->ItemIndex);
    --EventList->ItemIndex;
    EventClear();

    if (EventList->Items->Count==0) EventRemove->Enabled = false;
}
//---------------------------------------------------------------------------

void __fastcall TTileDescForm::EventListClick(TObject *Sender)
{
    //Update Display of Event attributes to reflect new selection
    NWEvent *thisEvent = (NWEvent *)nwt->EventList->Items[EventList->ItemIndex];
    EventName->Text     = thisEvent->Name;
    EventLocation->Text = thisEvent->Location;
    EventTrigger->Text  = thisEvent->Trigger;
    EventScript->Text   = thisEvent->Script;
    EventText->Lines->Clear();
    EventText->Lines->AddStrings(thisEvent->Text);
}
//---------------------------------------------------------------------------

void TTileDescForm::EventClear(void) {
    EventName->Text     = "";
    EventLocation->Text = "";
    EventTrigger->Text  = "";
    EventScript->Text   = "";
    EventText->Lines->Clear();
    EventList->ItemIndex = -1;
}
//---------------------------------------------------------------------------

void __fastcall TTileDescForm::PortalAddClick(TObject *Sender)
{
    NWPortal *newPortal = new NWPortal();
    newPortal->Name         = PortalName->Text;
    newPortal->Location     = PortalLocation->Text;
    newPortal->TargetMap    = PortalMap->Text;
    newPortal->TargetTile   = PortalTile->Text;
    newPortal->Restrictions = PortalLevel->Text;
    newPortal->Text->AddStrings(PortalText->Lines);

    nwt->PortalList->Add(newPortal);
    PortalList->Items->Add(PortalName->Text);
    PortalClear();

    PortalRemove->Enabled = true;
}
//---------------------------------------------------------------------------

void __fastcall TTileDescForm::PortalRemoveClick(TObject *Sender)
{
    nwt->PortalList->Delete(PortalList->ItemIndex);
    PortalList->Items->Delete(PortalList->ItemIndex);
    --PortalList->ItemIndex;
    PortalClear();

    if (PortalList->Items->Count==0) PortalRemove->Enabled = false;
}
//---------------------------------------------------------------------------

void __fastcall TTileDescForm::PortalListClick(TObject *Sender)
{
    //Update Display of Event attributes to reflect new selection
    NWPortal *thisPortal = (NWPortal *)nwt->PortalList->Items[PortalList->ItemIndex];
    PortalName->Text     = thisPortal->Name;
    PortalLocation->Text = thisPortal->Location;
    PortalMap->Text      = thisPortal->TargetMap;
    PortalTile->Text     = thisPortal->TargetTile;
    PortalLevel->Text    = thisPortal->Restrictions;
    PortalText->Lines->Clear();
    PortalText->Lines->AddStrings(thisPortal->Text);
}
//---------------------------------------------------------------------------

void TTileDescForm::PortalClear() {
    PortalName->Text     = "";
    PortalLocation->Text = "";
    PortalMap->Text      = "";
    PortalTile->Text     = "";
    PortalLevel->Text    = "";
    PortalText->Lines->Clear();
    PortalList->ItemIndex = -1;
}
//---------------------------------------------------------------------------


void __fastcall TTileDescForm::TEditKeyPress(TObject *Sender, char &Key)
{
    if (Key==VK_RETURN) Perform (WM_NEXTDLGCTL, 0, 0);
}
//---------------------------------------------------------------------------

void __fastcall TTileDescForm::NPCNewClick(TObject *Sender)
{
    NPCName->Text = "";
    NPCAlign->Text = "";
    NPCRace->Text = "";
    NPCClass->Text = "";
    NPCScript->Text = "";
    NPCText->Lines->Clear();
    NPCList->ItemIndex = -1;
}
//---------------------------------------------------------------------------

void __fastcall TTileDescForm::CreatNewClick(TObject *Sender)
{
    CreatName->Text = "";
    CreatType->Text = "";
    CreatWeapon->Text = "";
    CreatArmor->Text = "";
    CreatScript->Text = "";
    CreatText->Lines->Clear();
    CreatureList->ItemIndex = -1;
}
//---------------------------------------------------------------------------

void __fastcall TTileDescForm::ItemNewClick(TObject *Sender)
{
    ItemName->Text = "";
    ItemValue->Text = "";
    ItemScript->Text = "";
    ItemText->Lines->Clear();
    ItemList->ItemIndex = -1;
    ItemMoveable->Checked = false;
}
//---------------------------------------------------------------------------

void __fastcall TTileDescForm::EventNewClick(TObject *Sender)
{
    EventName->Text = "";
    EventLocation->Text = "";
    EventTrigger->Text = "";
    EventScript->Text = "";
    EventText->Lines->Clear();
    EventList->ItemIndex = -1;
}
//---------------------------------------------------------------------------

void __fastcall TTileDescForm::PortalNewClick(TObject *Sender)
{
    PortalName->Text = "";
    PortalLocation->Text = "";
    PortalMap->Text = "";
    PortalTile->Text = "";
    PortalLevel->Text = "";
    PortalText->Lines->Clear();
    PortalList->ItemIndex = -1;    
}
//---------------------------------------------------------------------------



