/***************************************************
 *                                                 *
 *   NWMap v. 1.1                                  *
 *   Copyright 2001, by Jason Harris               *
 *   http://nwmap.nwnonline.net/                   *
 *   nwmap@hotmail.com                             *
 *   jharris@30doradus.org                         *
 *                                                 *
 ***************************************************/
//---------------------------------------------------------------------------
#ifndef TilesetFormMainH
#define TilesetFormMainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>
#include "NWConst.h"
#include <ComCtrls.hpp>
#include <Buttons.hpp>
//---------------------------------------------------------------------------
class TTilesetForm : public TForm
{
__published:	// IDE-managed Components
    TPageControl *PageControl1;
    TTabSheet *Tab0;
    TTabSheet *Tab1;
    TTabSheet *Tab2;
    TTabSheet *Tab3;
    TTabSheet *Tab4;
    TPanel *Panel3;
    TCheckBox *CheckBox1;
    TCheckBox *CheckBox2;
    TCheckBox *CheckBox3;
    TCheckBox *CheckBox4;
    TCheckBox *CheckBox5;
    TCheckBox *CheckBox6;
    TCheckBox *CheckBox7;
    TCheckBox *CheckBox8;
    TCheckBox *CheckBox9;
    TCheckBox *CheckBox10;
    TEdit *TileTitle;
    TCheckBox *OnTopBox;
    TCheckBox *oneLayerBox;
    void __fastcall FormCreate(TObject *Sender);
    void __fastcall FormPaint(TObject *Sender);
    void __fastcall TileBoxMouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
    void __fastcall FormKeyPress(TObject *Sender, char &Key);
    void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
    void __fastcall FormShow(TObject *Sender);
    void __fastcall TileBoxMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
    void __fastcall PageControl1Change(TObject *Sender);
    void __fastcall ModeButtonClick(TObject *Sender);
    void __fastcall OnTopBoxClick(TObject *Sender);
    void __fastcall CheckBoxClick(TObject *Sender);
    void __fastcall oneLayerBoxClick(TObject *Sender);
private:	// User declarations
    void rotateTile(int SelectedTile, int nrot, int iLayer);
    void setGroups( int iLayer );
    Graphics::TBitmap *Tile, *Tile2;
    TRect SelectRect, SetRect, TileRect;
    int oldx, oldy, px, py;
public:		// User declarations
    __fastcall TTilesetForm(TComponent* Owner);
    void LoadTileset(int iset);
    void drawTiles(int iLayer);
    void getTile(Graphics::TBitmap *Tile, int iTile, int nrot, int iLayer);
    void drawTile(int iTile, int nrot, int iLayer);
    void drawCursor(int iTile, int iLayer, TColor c);
    Graphics::TBitmap *Tilebmp[4][TLAYER], *Rootbmp, *Tileset[TLAYER];
    TPaintBox *TileBox[TLAYER];
    TPanel *Panel[TLAYER][2];
    TSpeedButton *GButton[TLAYER][NGROUP];
    bool SeenIt[4][TLAYER][NTILES], UseLayer[TLAYER];
    int SizeFactor, CurrentLayer, numLayer;
    int XTileset[NTILES], YTileset[NTILES], Rotation[NTILES][TLAYER];
    int SelectedTile[TLAYER], BlankTile, iset;
    int BTile[TLAYER-1][NGROUP][4], BRot[TLAYER-1][NGROUP][4];
    int STile[TLAYER-1][NGROUP][4], SRot[TLAYER-1][NGROUP][4];
    int gType[TLAYER-1][NGROUP];
    int SCrossTile[TLAYER-1][NGROUP][4], SCReplaceTile[TLAYER-1][NGROUP][4], SCReplaceRot[TLAYER-1][NGROUP][4];
    int SEndFlag[TLAYER-1][NGROUP][4], SEndTile[TLAYER-1][NGROUP][4], SEndRot[TLAYER-1][NGROUP][4];
    TStringList *GroupNames[TLAYER], *TileNames[TLAYER];
};
//---------------------------------------------------------------------------
extern PACKAGE TTilesetForm *TilesetForm;
//---------------------------------------------------------------------------
#endif
